"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HiddenAdaptiveCardActivitySubscriber = void 0;
var _Constants = require("../../../../common/Constants");
var _TelemetryConstants = require("../../../../common/telemetry/TelemetryConstants");
var _TelemetryHelper = require("../../../../common/telemetry/TelemetryHelper");
var _omnichannelChatComponents = require("@microsoft/omnichannel-chat-components");
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
let HiddenAdaptiveCardActivitySubscriber = /*#__PURE__*/function () {
  function HiddenAdaptiveCardActivitySubscriber() {
    _classCallCheck(this, HiddenAdaptiveCardActivitySubscriber);
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    _defineProperty(this, "observer", void 0);
  }
  _createClass(HiddenAdaptiveCardActivitySubscriber, [{
    key: "apply",
    value:
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    async function apply(activity) {
      const {
        attachments,
        attachment
      } = activity;
      this.observer.next(false);
      _omnichannelChatComponents.BroadcastService.postMessage({
        eventName: _TelemetryConstants.BroadcastEvent.NewMessageReceived,
        payload: {
          attachments: attachments || [attachment],
          text: "Custom Event"
        }
      });
      return;
    }

    // eslint-disable-next-line @typescript-eslint/no-unused-vars, @typescript-eslint/no-explicit-any
  }, {
    key: "applicable",
    value: function applicable(activity) {
      const {
        attachments,
        attachment
      } = activity;

      // Use `attachments` or `attachment` (whichever exists)
      const cards = attachments || [attachment];

      // Check if contentType is "AdaptiveCard"
      const adaptiveCard = cards === null || cards === void 0 ? void 0 : cards.find(
      // eslint-disable-next-line @typescript-eslint/no-explicit-any
      item => _Constants.Constants.supportedAdaptiveCardContentTypes.indexOf(item === null || item === void 0 ? void 0 : item.contentType) >= 0);
      if (adaptiveCard && adaptiveCard.content) {
        const {
          body
        } = adaptiveCard.content;
        if (Array.isArray(body)) {
          // Check if all elements in `body` have `isVisible: false`
          const allInvisible = body.every(item => item.isVisible === false);
          if (allInvisible) {
            _TelemetryHelper.TelemetryHelper.logLoadingEvent(_TelemetryConstants.LogLevel.INFO, {
              Event: _TelemetryConstants.TelemetryEvent.HiddenAdaptiveCardMessageReceived,
              Description: "All elements in AdaptiveCard are invisible"
            });
            return true;
          }
        }
      }
      return false;
    }

    // eslint-disable-next-line @typescript-eslint/no-explicit-any
  }, {
    key: "next",
    value: async function next(activity) {
      if (this.applicable(activity)) {
        return await this.apply(activity);
      }
      return activity;
    }
  }]);
  return HiddenAdaptiveCardActivitySubscriber;
}();
exports.HiddenAdaptiveCardActivitySubscriber = HiddenAdaptiveCardActivitySubscriber;