"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getMockChatSDKIfApplicable = void 0;
var _DemoChatSDK = require("../../webchatcontainerstateful/common/DemoChatSDK");
var _DesignerChatSDK = require("../../webchatcontainerstateful/common/DesignerChatSDK");
var _mockchatsdk = require("../../webchatcontainerstateful/common/mockchatsdk");
// eslint-disable-next-line @typescript-eslint/no-explicit-any
const getMockChatSDKIfApplicable = (chatSDK, type) => {
  if (type) {
    switch (type.toLowerCase()) {
      case "demo":
        chatSDK = new _DemoChatSDK.DemoChatSDK();
        break;
      case "designer":
        chatSDK = new _DesignerChatSDK.DesignerChatSDK();
        break;
      default:
        chatSDK = new _mockchatsdk.MockChatSDK();
    }
  }
  return chatSDK;
};
exports.getMockChatSDKIfApplicable = getMockChatSDKIfApplicable;