"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.initCallingSdk = void 0;
var _TelemetryConstants = require("../../../common/telemetry/TelemetryConstants");
var _TelemetryHelper = require("../../../common/telemetry/TelemetryHelper");
// eslint-disable-next-line @typescript-eslint/no-explicit-any
const initCallingSdk = async (facadeChatSDK, setVoiceVideoCallingSDK) => {
  try {
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    if (facadeChatSDK.getChatSDK().getVoiceVideoCalling) {
      // eslint-disable-next-line @typescript-eslint/no-explicit-any
      const callingSDK = await facadeChatSDK.getChatSDK().getVoiceVideoCalling();
      setVoiceVideoCallingSDK(callingSDK);
      _TelemetryHelper.TelemetryHelper.logCallingEvent(_TelemetryConstants.LogLevel.INFO, {
        Event: _TelemetryConstants.TelemetryEvent.CallingSDKLoadSuccess
      });
      return true;
    }
    return false;
  } catch (error) {
    _TelemetryHelper.TelemetryHelper.logCallingEvent(_TelemetryConstants.LogLevel.ERROR, {
      Event: _TelemetryConstants.TelemetryEvent.CallingSDKLoadFailed,
      ExceptionDetails: {
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        exception: error.message
      }
    });
    return false;
  }
};
exports.initCallingSdk = initCallingSdk;