"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isPostChatSurveyEnabled = exports.isPersistentChatEnabled = void 0;
var _Constants = require("../../../common/Constants");
var _utils = require("../../../common/utils");
const isPostChatSurveyEnabled = async facadeChatSDK => {
  var _chatConfig$LiveWSAnd;
  const chatConfig = await facadeChatSDK.getLiveChatConfig();
  const postChatEnabled = (_chatConfig$LiveWSAnd = chatConfig.LiveWSAndLiveChatEngJoin) === null || _chatConfig$LiveWSAnd === void 0 ? void 0 : _chatConfig$LiveWSAnd.msdyn_postconversationsurveyenable.toString().toLowerCase();
  return postChatEnabled === "true";
};
exports.isPostChatSurveyEnabled = isPostChatSurveyEnabled;
const isPersistentChatEnabled = async conversationMode => {
  if ((0, _utils.isNullOrUndefined)(conversationMode)) {
    return false;
  }
  return (conversationMode === null || conversationMode === void 0 ? void 0 : conversationMode.toString().toLowerCase()) === _Constants.ConversationMode.Persistent;
};
exports.isPersistentChatEnabled = isPersistentChatEnabled;