"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.shouldSetPreChatIfPersistentChat = void 0;
var _liveChatConfigUtils = require("./liveChatConfigUtils");
// eslint-disable-next-line @typescript-eslint/no-explicit-any
const shouldSetPreChatIfPersistentChat = async (chatSDK, conversationMode, showPreChat) => {
  const persistentEnabled = await (0, _liveChatConfigUtils.isPersistentChatEnabled)(conversationMode);
  let skipPreChat = false;
  if (persistentEnabled) {
    const reconnectableChatsParams = {
      authenticatedUserToken: chatSDK.authenticatedUserToken,
      requestId: chatSDK.requestId
    };
    try {
      const reconnectableChatsResponse = await chatSDK.OCClient.getReconnectableChats(reconnectableChatsParams);
      if (reconnectableChatsResponse && reconnectableChatsResponse.reconnectid) {
        // Skip rendering prechat on existing persistent chat session
        skipPreChat = true;
      }
    } catch {
      // eslint-disable-line no-empty
    }
  }
  return showPreChat && !skipPreChat;
};
exports.shouldSetPreChatIfPersistentChat = shouldSetPreChatIfPersistentChat;