"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.shareObservable = shareObservable;
// eslint-disable-next-line @typescript-eslint/no-explicit-any
function shareObservable(observable) {
  // eslint-disable-next-line @typescript-eslint/no-explicit-any
  let observers = [];

  // eslint-disable-next-line @typescript-eslint/no-explicit-any
  let subscription;

  // eslint-disable-next-line @typescript-eslint/no-explicit-any
  return new window.Observable(observer => {
    if (!subscription) {
      subscription = observable.subscribe({
        complete() {
          observers.forEach(observer => observer.complete());
        },
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        error(err) {
          observers.forEach(observer => observer.error(err));
        },
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        next(value) {
          observers.forEach(observer => observer.next(value));
        }
      });
    }
    observers.push(observer);
    return () => {
      observers = observers.filter(o => o !== observer);
      if (!observers.length) {
        subscription.unsubscribe();
        subscription = null;
      }
    };
  });
}