"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _utils = require("../../../common/utils");
const validRootDomains = ["microsoft.com", "microsoft.us", "appsplatform.us", "powervirtualagents.cn"];
const isValidSurveyUrl = url => {
  if ((0, _utils.isNullOrEmptyString)(url)) {
    return false;
  }
  try {
    const objectUrl = new URL(url);
    if (!objectUrl.origin || objectUrl.origin === "null") {
      return false;
    }
    const validDomain = validRootDomains.find(domain => objectUrl.origin.endsWith(domain));
    if (validDomain) {
      return true;
    }
  } catch (error) {
    return false;
  }
  return false;
};
var _default = isValidSurveyUrl;
exports.default = _default;