"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DemoChatAdapter = void 0;
require("rxjs/add/operator/share");
require("rxjs/add/observable/of");
var _Observable = require("rxjs/Observable");
var _mockadapter = _interopRequireDefault(require("./mockadapter"));
var _chatAdapterUtils = require("./utils/chatAdapterUtils");
var _attachmentActivityUtils = require("./utils/attachmentActivityUtils");
var _MockBotCommand = _interopRequireDefault(require("./MockBotCommand"));
var _MockBotCardCommandType = _interopRequireDefault(require("./MockBotCardCommandType"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
let DemoChatAdapter = /*#__PURE__*/function (_MockAdapter) {
  _inherits(DemoChatAdapter, _MockAdapter);
  var _super = _createSuper(DemoChatAdapter);
  function DemoChatAdapter() {
    var _this;
    _classCallCheck(this, DemoChatAdapter);
    _this = _super.call(this);
    setTimeout(() => {
      (0, _chatAdapterUtils.postSystemMessageActivity)(_this.activityObserver, "You're currently using a demo.", 0);
      (0, _chatAdapterUtils.postBotMessageActivity)(_this.activityObserver, "Type `/help` to learn more", undefined, 0); // send init message from bot
    }, 1000);
    return _this;
  }
  _createClass(DemoChatAdapter, [{
    key: "postBotCommandsActivity",
    value: function postBotCommandsActivity() {
      let delay = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1000;
      (0, _chatAdapterUtils.postBotAttachmentActivity)(this.activityObserver, [{
        contentType: "application/vnd.microsoft.card.thumbnail",
        content: {
          buttons: [{
            title: "Send system message",
            type: "imBack",
            value: "send system message"
          }, {
            title: "Send typing",
            type: "imBack",
            value: "send typing"
          }, {
            title: "Send bot message",
            type: "imBack",
            value: "send bot message"
          }],
          title: "Commands"
        }
      }], delay);
    }
  }, {
    key: "postActivity",
    value: function postActivity(activity) {
      if (activity) {
        (0, _chatAdapterUtils.postEchoActivity)(this.activityObserver, activity, _chatAdapterUtils.customerUser);
        if (activity.text) {
          switch (true) {
            case activity.text === _MockBotCommand.default.Help:
              this.postBotCommandsActivity();
              break;
            case activity.text === _MockBotCommand.default.SendSystemMessage:
              (0, _chatAdapterUtils.postSystemMessageActivity)(this.activityObserver, "Contoso has joined the chat.");
              break;
            case activity.text === _MockBotCommand.default.SendTyping:
              (0, _chatAdapterUtils.postBotTypingActivity)(this.activityObserver);
              break;
            case activity.text === _MockBotCommand.default.SendAttachment:
              (0, _chatAdapterUtils.postBotAttachmentActivity)(this.activityObserver, [(0, _attachmentActivityUtils.createJpgFileAttachment)()]);
              break;
            case activity.text === _MockBotCommand.default.SendBotMessage:
              (0, _chatAdapterUtils.postBotMessageActivity)(this.activityObserver, "Hi, how can I help you?");
              break;
            case activity.text === `${_MockBotCommand.default.Card} ${_MockBotCardCommandType.default.Signin}`:
              (0, _chatAdapterUtils.postBotAttachmentActivity)(this.activityObserver, [(0, _attachmentActivityUtils.createSigninCardAttachment)()]);
              break;
            case activity.text === `${_MockBotCommand.default.Card} ${_MockBotCardCommandType.default.Hero}`:
              (0, _chatAdapterUtils.postBotAttachmentActivity)(this.activityObserver, [(0, _attachmentActivityUtils.createHeroCardAttachment)()]);
              break;
            case activity.text === `${_MockBotCommand.default.Card} ${_MockBotCardCommandType.default.Thumbnail}`:
              (0, _chatAdapterUtils.postBotAttachmentActivity)(this.activityObserver, [(0, _attachmentActivityUtils.createThumbnailCardAttachment)()]);
              break;
            case activity.text.startsWith(`${_MockBotCommand.default.Bot} `):
              (0, _chatAdapterUtils.postBotMessageActivity)(this.activityObserver, activity.text.substring(5));
              break;
            case activity.text.startsWith(`${_MockBotCommand.default.System} `):
              (0, _chatAdapterUtils.postSystemMessageActivity)(this.activityObserver, activity.text.substring(8));
              break;
          }
        }
      }
      return _Observable.Observable.of(activity.id || "");
    }
  }]);
  return DemoChatAdapter;
}(_mockadapter.default);
exports.DemoChatAdapter = DemoChatAdapter;