"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isMaskingforCustomer = void 0;
var _utils = require("../../../../common/utils");
const isMaskingforCustomer = maskingInfo => {
  var _maskingInfo$setting;
  // If the masking info (containing masking setting and masking rules) is missing or empty, return false.
  // If the masking rules are missing or empty, also return false.
  if (!maskingInfo || Object.keys(maskingInfo).length == 0 || !maskingInfo.dataMaskingRules || Object.keys(maskingInfo.dataMaskingRules).length == 0) {
    return false;
  }

  // If the masking rules are provided and;
  // If the masking setting is NOT null and masking for customer is NOT null, return the configuration
  if (!(0, _utils.isNullOrUndefined)((_maskingInfo$setting = maskingInfo.setting) === null || _maskingInfo$setting === void 0 ? void 0 : _maskingInfo$setting.msdyn_maskforcustomer)) {
    var _maskingInfo$setting2;
    return (0, _utils.parseLowerCaseString)(maskingInfo === null || maskingInfo === void 0 ? void 0 : (_maskingInfo$setting2 = maskingInfo.setting) === null || _maskingInfo$setting2 === void 0 ? void 0 : _maskingInfo$setting2.msdyn_maskforcustomer) === "true";
  }

  // In all other cases, even if masking setting is missing, return true to apply the masking for backward compatibility (i.e. in old versions, OC does not have masking info settings)
  return true;
};
exports.isMaskingforCustomer = isMaskingforCustomer;