"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _TelemetryConstants = require("../../../../../common/telemetry/TelemetryConstants");
var _TelemetryHelper = require("../../../../../common/telemetry/TelemetryHelper");
// eslint-disable-next-line @typescript-eslint/no-explicit-any
const FormatEgressTagsMiddleware = () => next => activity => {
  const activity_instance = JSON.parse(JSON.stringify(activity));
  if (activity_instance) {
    if (activity_instance.channelData && activity_instance.channelData.tags) {
      const {
        tags
      } = activity_instance.channelData;
      if (typeof tags === "string") {
        return next(activity);
      } else if (tags instanceof Array) {
        activity_instance.channelData.tags = tags.toString();
      } else if (typeof activity_instance.channelData.tags === "object") {
        try {
          activity_instance.channelData.tags = JSON.stringify(tags);
        } catch (exception) {
          _TelemetryHelper.TelemetryHelper.logActionEvent(_TelemetryConstants.LogLevel.ERROR, {
            Event: _TelemetryConstants.TelemetryEvent.FormatTagsMiddlewareJSONStringifyFailed,
            ExceptionDetails: {
              exception: exception
            }
          });
        }
      }
    }
  }
  return next(activity_instance);
};
var _default = FormatEgressTagsMiddleware;
exports.default = _default;