"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _useChatContextStore = _interopRequireDefault(require("../../../../../../hooks/useChatContextStore"));
var _defaultAttachmentProps = require("../../../../common/defaultProps/defaultAttachmentProps");
var _defaultAttachmentContentStyles = require("../defaultStyles/defaultAttachmentContentStyles");
var _defaultAttachmentDividerStyles = require("../defaultStyles/defaultAttachmentDividerStyles");
var _defaultAttachmentDownloadIconStyles = require("../defaultStyles/defaultAttachmentDownloadIconStyles");
var _defaultAttachmentFileNameStyles = require("../defaultStyles/defaultAttachmentFileNameStyles");
var _defaultAttachmentSizeStyles = require("../defaultStyles/defaultAttachmentSizeStyles");
var _defaultAtttachmentIconStyles = require("../defaultStyles/defaultAtttachmentIconStyles");
var _defaultAtttachmentStyles = require("../defaultStyles/defaultAtttachmentStyles");
var _AttachmentContent = _interopRequireDefault(require("./AttachmentContent"));
var _AttachmentIcon = _interopRequireDefault(require("./AttachmentIcon"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
const Attachment = props => {
  var _state$domainStates$r, _state$domainStates$r2, _state$domainStates$r3, _state$domainStates$r4, _state$domainStates$r5, _state$domainStates$r6, _state$domainStates$r7, _state$domainStates$r8, _state$domainStates$r9;
  // eslint-disable-line @typescript-eslint/no-explicit-any
  const {
    iconData,
    imageCard,
    textCard,
    renderer
  } = props;
  const [state] = (0, _useChatContextStore.default)();
  const attachmentId = ((_state$domainStates$r = state.domainStates.renderingMiddlewareProps) === null || _state$domainStates$r === void 0 ? void 0 : (_state$domainStates$r2 = _state$domainStates$r.attachmentProps) === null || _state$domainStates$r2 === void 0 ? void 0 : _state$domainStates$r2.webChatAttachmentId) ?? _defaultAttachmentProps.defaultAttachmentProps.webChatAttachmentId;
  const attachmentDividerStyles = {
    ..._defaultAttachmentDividerStyles.defaultAttachmentDividerStyles,
    ...((_state$domainStates$r3 = state.domainStates.renderingMiddlewareProps) === null || _state$domainStates$r3 === void 0 ? void 0 : _state$domainStates$r3.attachmentDividerStyles)
  };
  const attachmentIconStyles = {
    ..._defaultAtttachmentIconStyles.defaultAttachmentIconStyles,
    ...((_state$domainStates$r4 = state.domainStates.renderingMiddlewareProps) === null || _state$domainStates$r4 === void 0 ? void 0 : _state$domainStates$r4.attachmentIconStyles)
  };
  const attachmentStyles = {
    ..._defaultAtttachmentStyles.defaultAttachmentStyles,
    ...((_state$domainStates$r5 = state.domainStates.renderingMiddlewareProps) === null || _state$domainStates$r5 === void 0 ? void 0 : _state$domainStates$r5.attachmentStyles)
  };
  const attachmentSizeStylesString = Object.entries({
    ..._defaultAttachmentSizeStyles.defaultAttachmentSizeStyles,
    ...((_state$domainStates$r6 = state.domainStates.renderingMiddlewareProps) === null || _state$domainStates$r6 === void 0 ? void 0 : _state$domainStates$r6.attachmentSizeStyles)
  }).map(_ref => {
    let [k, v] = _ref;
    return `${k.replace(/[A-Z]/g, match => `-${match.toLowerCase()}`)}:${v}`;
  }).join(";");
  const attachmentContentStylesString = Object.entries({
    ..._defaultAttachmentContentStyles.defaultAttachmentContentStyles,
    ...((_state$domainStates$r7 = state.domainStates.renderingMiddlewareProps) === null || _state$domainStates$r7 === void 0 ? void 0 : _state$domainStates$r7.attachmentContentStyles)
  }).map(_ref2 => {
    let [k, v] = _ref2;
    return `${k.replace(/[A-Z]/g, match => `-${match.toLowerCase()}`)}:${v}`;
  }).join(";");
  const attachmentFileNameStylesString = Object.entries({
    ..._defaultAttachmentFileNameStyles.defaultAttachmentFileNameStyles,
    ...((_state$domainStates$r8 = state.domainStates.renderingMiddlewareProps) === null || _state$domainStates$r8 === void 0 ? void 0 : _state$domainStates$r8.attachmentFileNameStyles)
  }).map(_ref3 => {
    let [k, v] = _ref3;
    return `${k.replace(/[A-Z]/g, match => `-${match.toLowerCase()}`)}:${v}`;
  }).join(";");
  const attachmentDownloadIconStylesString = Object.entries({
    ..._defaultAttachmentDownloadIconStyles.defaultAttachmentDownloadIconStyles,
    ...((_state$domainStates$r9 = state.domainStates.renderingMiddlewareProps) === null || _state$domainStates$r9 === void 0 ? void 0 : _state$domainStates$r9.attachmentDownloadIconStyles)
  }).map(_ref4 => {
    let [k, v] = _ref4;
    return `${k.replace(/[A-Z]/g, match => `-${match.toLowerCase()}`)}:${v}`;
  }).join(";");
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("style", null, `
            .webchat__fileContent__size { ${attachmentSizeStylesString} }
            .webchat__fileContent { ${attachmentContentStylesString} }
            .webchat__fileContent__fileName { ${attachmentFileNameStylesString} }
            .webchat__fileContent__downloadIcon { ${attachmentDownloadIconStylesString} }
        `), /*#__PURE__*/_react.default.createElement("div", {
    dir: state.domainStates.globalDir
  }, imageCard && renderer(imageCard), imageCard && /*#__PURE__*/_react.default.createElement("hr", {
    id: attachmentId + "-divider",
    style: attachmentDividerStyles
  }), /*#__PURE__*/_react.default.createElement(_AttachmentContent.default, {
    attachment: textCard.attachment,
    id: attachmentId,
    style: attachmentStyles
  }, /*#__PURE__*/_react.default.createElement(_AttachmentIcon.default, {
    src: iconData,
    id: attachmentId + "-icon",
    style: attachmentIconStyles
  }), textCard && renderer(textCard))));
};
var _default = Attachment;
exports.default = _default;