"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DeliveredTimestamp = void 0;
var _react = _interopRequireDefault(require("react"));
var _DirectLineSenderRole = require("../../../enums/DirectLineSenderRole");
var _react2 = require("@fluentui/react");
var _defaultMiddlewareLocalizedTexts = require("../../../../common/defaultProps/defaultMiddlewareLocalizedTexts");
var _defaultTimestampContentStyles = require("../defaultStyles/defaultTimestampContentStyles");
var _utils = require("../../../../../../common/utils");
var _ = require("../../../../../..");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
/* eslint @typescript-eslint/no-explicit-any: "off" */
const DeliveredTimestamp = _ref => {
  var _state$domainStates$r, _state$domainStates$r2, _state$domainStates$m;
  let {
    args,
    role,
    name
  } = _ref;
  const [state] = (0, _.useChatContextStore)();
  const dir = ((_state$domainStates$r = state.domainStates.renderingMiddlewareProps) === null || _state$domainStates$r === void 0 ? void 0 : _state$domainStates$r.timestampDir) ?? state.domainStates.globalDir;
  const contentStyles = {
    ..._defaultTimestampContentStyles.defaultTimestampContentStyles,
    ...((_state$domainStates$r2 = state.domainStates.renderingMiddlewareProps) === null || _state$domainStates$r2 === void 0 ? void 0 : _state$domainStates$r2.timestampContentStyleProps)
  };
  const {
    activity: {
      timestamp
    }
  } = args;
  const getTimeElement = timestamp => {
    const timeString = (0, _utils.getTimestampHourMinute)(timestamp);
    const isAmPmFormat = timeString.toLowerCase().includes("am") || timeString.toLowerCase().includes("pm");

    // For clients that use languages that are written right-to-left, but still use AM/PM time format, we need to
    // make sure the "rtl" direction doesn't produce "PM 1:23", but remains "1:23 PM"
    if (dir === "rtl" && isAmPmFormat) {
      return /*#__PURE__*/_react.default.createElement("span", {
        dir: "ltr"
      }, (0, _utils.getTimestampHourMinute)(timestamp));
    } else {
      return /*#__PURE__*/_react.default.createElement("span", {
        dir: dir
      }, (0, _utils.getTimestampHourMinute)(timestamp));
    }
    return timeString;
  };
  return /*#__PURE__*/_react.default.createElement(_react2.Stack, {
    style: contentStyles,
    dir: dir
  }, role === _DirectLineSenderRole.DirectLineSenderRole.Bot && /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("span", {
    dir: dir,
    "aria-hidden": "false"
  }, name, " - ", getTimeElement(timestamp))), role === _DirectLineSenderRole.DirectLineSenderRole.User && /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("span", {
    "aria-hidden": "false",
    dir: dir
  }, " ", getTimeElement(timestamp), " - ", ((_state$domainStates$m = state.domainStates.middlewareLocalizedTexts) === null || _state$domainStates$m === void 0 ? void 0 : _state$domainStates$m.MIDDLEWARE_MESSAGE_DELIVERED) ?? _defaultMiddlewareLocalizedTexts.defaultMiddlewareLocalizedTexts.MIDDLEWARE_MESSAGE_DELIVERED)));
};
exports.DeliveredTimestamp = DeliveredTimestamp;