"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createToastMiddleware = void 0;
var _react = _interopRequireDefault(require("react"));
var _NotificationScenarios = require("../../enums/NotificationScenarios");
var _NotificationPaneStateful = _interopRequireDefault(require("../../../../notificationpanestateful/NotificationPaneStateful"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
// eslint-disable-next-line @typescript-eslint/no-explicit-any
const createToastMiddleware = (notificationPaneProps, endChat) => {
  // eslint-disable-next-line @typescript-eslint/no-explicit-any, react/display-name
  const toastMiddleware = () => next => card => {
    const {
      notification
    } = card;
    if (notificationPaneProps) {
      if (notification.id === _NotificationScenarios.NotificationScenarios.ChatDisconnect) {
        return /*#__PURE__*/_react.default.createElement(_NotificationPaneStateful.default, {
          notificationPaneProps: notificationPaneProps,
          notificationScenarioType: _NotificationScenarios.NotificationScenarios.ChatDisconnect,
          endChat: endChat
        });
      }

      // TODO: additional notification scenarios to be added...
    }

    return next(card);
  };
  return toastMiddleware;
};
exports.createToastMiddleware = createToastMiddleware;