"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _Constants = require("../../../../../common/Constants");
var _WebChatActionType = require("../../enums/WebChatActionType");
/******
 * GIFUploadMiddleware
 * 
 * Ensures that GIF are properly uploaded.
 ******/

// eslint-disable-next-line @typescript-eslint/no-explicit-any, @typescript-eslint/no-unused-vars
const gifUploadMiddleware = _ref => {
  let {
    dispatch
  } = _ref;
  return next => action => {
    if (action.type === _WebChatActionType.WebChatActionType.DIRECT_LINE_POST_ACTIVITY) {
      var _activity$attachments, _activity$channelData, _activity$channelData2;
      const {
        payload: {
          activity
        }
      } = action;
      if ((activity === null || activity === void 0 ? void 0 : (_activity$attachments = activity.attachments) === null || _activity$attachments === void 0 ? void 0 : _activity$attachments.length) === (activity === null || activity === void 0 ? void 0 : (_activity$channelData = activity.channelData) === null || _activity$channelData === void 0 ? void 0 : (_activity$channelData2 = _activity$channelData.attachmentSizes) === null || _activity$channelData2 === void 0 ? void 0 : _activity$channelData2.length)) {
        var _activity$attachments2;
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        activity === null || activity === void 0 ? void 0 : (_activity$attachments2 = activity.attachments) === null || _activity$attachments2 === void 0 ? void 0 : _activity$attachments2.forEach(attachment => {
          const {
            thumbnailUrl,
            contentUrl,
            contentType
          } = attachment;
          if (contentType === _Constants.Constants.GifContentType && thumbnailUrl !== contentUrl) {
            attachment.thumbnailUrl = contentUrl;
          }
        });
      }
    }
    return next(action);
  };
};
var _default = gifUploadMiddleware;
exports.default = _default;