"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _Constants = require("../../../../../common/Constants");
var _WebChatActionType = require("../../enums/WebChatActionType");
/******
 * PreProcessingMiddleware
 * 
 * Adds necessary fields for the activity for the other middlewares to function as expected.
 ******/

// eslint-disable-next-line @typescript-eslint/no-unused-vars, @typescript-eslint/no-explicit-any
const preProcessingMiddleware = _ref => {
  let {
    dispatch
  } = _ref;
  return next => async action => {
    if (action.type === _WebChatActionType.WebChatActionType.DIRECT_LINE_POST_ACTIVITY) {
      const {
        activity
      } = action.payload;
      if (!activity.from || activity.from.role === _Constants.Constants.userMessageTag) {
        action = {
          ...action,
          payload: {
            ...action.payload,
            activity: {
              ...action.payload.activity,
              textFormat: _Constants.Constants.markdown
            }
          }
        };
      }
    }
    if (action.type === _WebChatActionType.WebChatActionType.DIRECT_LINE_INCOMING_ACTIVITY) {
      const {
        activity
      } = action.payload;
      if (activity) {
        action.payload.activity[_Constants.Constants.actionType] = _WebChatActionType.WebChatActionType.DIRECT_LINE_INCOMING_ACTIVITY;
      }
    }
    return next(action);
  };
};
var _default = preProcessingMiddleware;
exports.default = _default;