"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = useDebounce;
var _react = require("react");
function useDebounce(func) {
  let delay = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1000;
  const timer = (0, _react.useRef)();
  (0, _react.useEffect)(() => {
    return () => {
      if (!timer.current) return;
      clearTimeout(timer.current);
    };
  }, []);
  const debouncedFunction = function () {
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    const newTimer = setTimeout(() => {
      func(...args);
    }, delay);
    clearTimeout(timer.current);
    timer.current = newTimer;
  };
  return debouncedFunction;
}