"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = useWindowDimensions;
var _react = require("react");
var _useDebounce = _interopRequireDefault(require("./useDebounce"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function getWindowDimensions() {
  const {
    innerWidth: width,
    innerHeight: height
  } = window;
  return {
    width,
    height
  };
}
function useWindowDimensions() {
  let delay = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 200;
  const [windowDimensions, setWindowDimensions] = (0, _react.useState)(getWindowDimensions());
  const handleResize = () => setWindowDimensions(getWindowDimensions());
  const debouncedHandleResize = (0, _useDebounce.default)(handleResize, delay);
  (0, _react.useEffect)(() => {
    window.addEventListener("resize", debouncedHandleResize);
    return () => window.removeEventListener("resize", debouncedHandleResize);
  }, []);
  return windowDimensions;
}