"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  BroadcastService: true,
  decodeComponentString: true,
  encodeComponentString: true,
  getWidgetCacheId: true,
  getWidgetEndChatEventName: true,
  ConversationState: true,
  useChatContextStore: true,
  useChatSDKStore: true,
  useFacadeChatSDKStore: true,
  LiveChatWidget: true,
  getMockChatSDKIfApplicable: true
};
Object.defineProperty(exports, "BroadcastService", {
  enumerable: true,
  get: function () {
    return _omnichannelChatComponents.BroadcastService;
  }
});
Object.defineProperty(exports, "ConversationState", {
  enumerable: true,
  get: function () {
    return _ConversationState.ConversationState;
  }
});
Object.defineProperty(exports, "LiveChatWidget", {
  enumerable: true,
  get: function () {
    return _LiveChatWidget.default;
  }
});
Object.defineProperty(exports, "decodeComponentString", {
  enumerable: true,
  get: function () {
    return _omnichannelChatComponents.decodeComponentString;
  }
});
Object.defineProperty(exports, "encodeComponentString", {
  enumerable: true,
  get: function () {
    return _omnichannelChatComponents.encodeComponentString;
  }
});
Object.defineProperty(exports, "getMockChatSDKIfApplicable", {
  enumerable: true,
  get: function () {
    return _getMockChatSDKIfApplicable.getMockChatSDKIfApplicable;
  }
});
Object.defineProperty(exports, "getWidgetCacheId", {
  enumerable: true,
  get: function () {
    return _utils.getWidgetCacheId;
  }
});
Object.defineProperty(exports, "getWidgetEndChatEventName", {
  enumerable: true,
  get: function () {
    return _utils.getWidgetEndChatEventName;
  }
});
Object.defineProperty(exports, "useChatContextStore", {
  enumerable: true,
  get: function () {
    return _useChatContextStore.default;
  }
});
Object.defineProperty(exports, "useChatSDKStore", {
  enumerable: true,
  get: function () {
    return _useChatSDKStore.default;
  }
});
Object.defineProperty(exports, "useFacadeChatSDKStore", {
  enumerable: true,
  get: function () {
    return _useFacadeChatSDKStore.default;
  }
});
var _omnichannelChatComponents = require("@microsoft/omnichannel-chat-components");
var _utils = require("./common/utils");
var _ConversationState = require("./contexts/common/ConversationState");
var _useChatContextStore = _interopRequireDefault(require("./hooks/useChatContextStore"));
var _useChatSDKStore = _interopRequireDefault(require("./hooks/useChatSDKStore"));
var _useFacadeChatSDKStore = _interopRequireDefault(require("./hooks/useFacadeChatSDKStore"));
var _LiveChatWidget = _interopRequireDefault(require("./components/livechatwidget/LiveChatWidget"));
var _getMockChatSDKIfApplicable = require("./components/livechatwidget/common/getMockChatSDKIfApplicable");
var _renderingmiddlewares = require("./components/webchatcontainerstateful/webchatcontroller/middlewares/renderingmiddlewares");
Object.keys(_renderingmiddlewares).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _renderingmiddlewares[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _renderingmiddlewares[key];
    }
  });
});
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }