"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _utils = require("../common/utils");
var _defaultLibraryScripts = _interopRequireDefault(require("../components/footerstateful/downloadtranscriptstateful/common/defaultLibraryScripts"));
var _dompurify = _interopRequireDefault(require("dompurify"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
let TranscriptHTMLBuilder = /*#__PURE__*/function () {
  // eslint-disable-line @typescript-eslint/no-explicit-any

  function TranscriptHTMLBuilder(options) {
    var _this$options, _this$options2, _this$options3, _this$options4, _this$options5, _this$options6, _this$options7, _this$options8, _this$options9, _this$options10, _this$options11, _this$options12, _this$options13;
    _classCallCheck(this, TranscriptHTMLBuilder);
    _defineProperty(this, "options", void 0);
    _defineProperty(this, "pageTitle", "Customer Transcript");
    _defineProperty(this, "attachmentMessage", "The following attachment was uploaded during the conversation: ");
    _defineProperty(this, "networkOnlineMessage", "Connection restored. Please refresh the page");
    _defineProperty(this, "networkOfflineMessage", "Network Error. Please make sure you are connected to the internet.");
    _defineProperty(this, "transcriptBackgroundColor", "#FFF");
    _defineProperty(this, "agentAvatarBackgroundColor", "#E8E8E8");
    _defineProperty(this, "agentAvatarFontColor", "#000");
    _defineProperty(this, "customerAvatarBackgroundColor", "#2266E3");
    _defineProperty(this, "customerAvatarFontColor", "#FFF");
    _defineProperty(this, "customerDisplayName", "");
    _defineProperty(this, "disableMarkdownMessageFormatting", false);
    _defineProperty(this, "disableNewLineMarkdownSupport", false);
    _defineProperty(this, "externalScripts", {});
    // eslint-disable-line @typescript-eslint/no-explicit-any
    this.options = options;
    if (!this.options || !this.options.messages) {
      this.options.messages = [];
    }
    if ((_this$options = this.options) !== null && _this$options !== void 0 && _this$options.pageTitle) {
      this.pageTitle = this.options.pageTitle;
    }
    if ((_this$options2 = this.options) !== null && _this$options2 !== void 0 && _this$options2.attachmentMessage) {
      this.attachmentMessage = this.options.attachmentMessage;
    }
    if ((_this$options3 = this.options) !== null && _this$options3 !== void 0 && _this$options3.networkOnlineMessage) {
      this.networkOnlineMessage = this.options.networkOnlineMessage;
    }
    if ((_this$options4 = this.options) !== null && _this$options4 !== void 0 && _this$options4.networkOfflineMessage) {
      this.networkOfflineMessage = this.options.networkOfflineMessage;
    }
    if ((_this$options5 = this.options) !== null && _this$options5 !== void 0 && _this$options5.transcriptBackgroundColor) {
      this.transcriptBackgroundColor = this.options.transcriptBackgroundColor;
    }
    if ((_this$options6 = this.options) !== null && _this$options6 !== void 0 && _this$options6.agentAvatarBackgroundColor) {
      this.agentAvatarBackgroundColor = this.options.agentAvatarBackgroundColor;
    }
    if ((_this$options7 = this.options) !== null && _this$options7 !== void 0 && _this$options7.agentAvatarFontColor) {
      this.agentAvatarFontColor = this.options.agentAvatarFontColor;
    }
    if ((_this$options8 = this.options) !== null && _this$options8 !== void 0 && _this$options8.customerAvatarBackgroundColor) {
      this.customerAvatarBackgroundColor = this.options.customerAvatarBackgroundColor;
    }
    if ((_this$options9 = this.options) !== null && _this$options9 !== void 0 && _this$options9.customerAvatarFontColor) {
      this.customerAvatarFontColor = this.options.customerAvatarFontColor;
    }
    if ((_this$options10 = this.options) !== null && _this$options10 !== void 0 && _this$options10.customerDisplayName) {
      this.customerDisplayName = this.options.customerDisplayName;
    }
    if ((_this$options11 = this.options) !== null && _this$options11 !== void 0 && _this$options11.disableMarkdownMessageFormatting) {
      this.disableMarkdownMessageFormatting = this.options.disableMarkdownMessageFormatting;
    }
    if ((_this$options12 = this.options) !== null && _this$options12 !== void 0 && _this$options12.disableNewLineMarkdownSupport) {
      this.disableNewLineMarkdownSupport = this.options.disableNewLineMarkdownSupport;
    }
    if ((_this$options13 = this.options) !== null && _this$options13 !== void 0 && _this$options13.externalScripts) {
      this.externalScripts = this.options.externalScripts;
    }
  }
  _createClass(TranscriptHTMLBuilder, [{
    key: "createMetaElement",
    value: function createMetaElement() {
      const htmlData = `
            <meta charset="UTF-8">
        `;
      return htmlData;
    }
  }, {
    key: "createTitleElement",
    value: function createTitleElement() {
      const htmlData = `<title> ${this.pageTitle} </title>`;
      return htmlData;
    }
  }, {
    key: "createScriptElement",
    value: function createScriptElement(src) {
      let integrity = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : undefined;
      let crossOrigin = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : undefined;
      let referrerPolicy = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : undefined;
      return `<script src="${src}" ${integrity ? `integrity="${integrity}"` : ""} ${crossOrigin ? `crossorigin="${crossOrigin}"` : ""} ${referrerPolicy ? `referrerpolicy="${referrerPolicy}"` : ""}><\/script>`;
    }
  }, {
    key: "createWebChatScriptElement",
    value: function createWebChatScriptElement() {
      var _this$externalScripts, _this$externalScripts2, _this$externalScripts3, _this$externalScripts4, _this$externalScripts5, _this$externalScripts6, _this$externalScripts7, _this$externalScripts8, _this$externalScripts9, _this$externalScripts10;
      return (_this$externalScripts = this.externalScripts) !== null && _this$externalScripts !== void 0 && (_this$externalScripts2 = _this$externalScripts.botframeworkWebChat) !== null && _this$externalScripts2 !== void 0 && _this$externalScripts2.src ? this.createScriptElement((_this$externalScripts3 = this.externalScripts) === null || _this$externalScripts3 === void 0 ? void 0 : (_this$externalScripts4 = _this$externalScripts3.botframeworkWebChat) === null || _this$externalScripts4 === void 0 ? void 0 : _this$externalScripts4.src, (_this$externalScripts5 = this.externalScripts) === null || _this$externalScripts5 === void 0 ? void 0 : (_this$externalScripts6 = _this$externalScripts5.botframeworkWebChat) === null || _this$externalScripts6 === void 0 ? void 0 : _this$externalScripts6.integrity, (_this$externalScripts7 = this.externalScripts) === null || _this$externalScripts7 === void 0 ? void 0 : (_this$externalScripts8 = _this$externalScripts7.botframeworkWebChat) === null || _this$externalScripts8 === void 0 ? void 0 : _this$externalScripts8.crossOrigin, (_this$externalScripts9 = this.externalScripts) === null || _this$externalScripts9 === void 0 ? void 0 : (_this$externalScripts10 = _this$externalScripts9.botframeworkWebChat) === null || _this$externalScripts10 === void 0 ? void 0 : _this$externalScripts10.referrerPolicy) : this.createScriptElement(_defaultLibraryScripts.default.botframeworkWebChat.src);
    }
  }, {
    key: "createRxJsScriptElement",
    value: function createRxJsScriptElement() {
      var _this$externalScripts11, _this$externalScripts12, _this$externalScripts13, _this$externalScripts14, _this$externalScripts15, _this$externalScripts16, _this$externalScripts17, _this$externalScripts18, _this$externalScripts19, _this$externalScripts20;
      return (_this$externalScripts11 = this.externalScripts) !== null && _this$externalScripts11 !== void 0 && (_this$externalScripts12 = _this$externalScripts11.rxJs) !== null && _this$externalScripts12 !== void 0 && _this$externalScripts12.src ? this.createScriptElement((_this$externalScripts13 = this.externalScripts) === null || _this$externalScripts13 === void 0 ? void 0 : (_this$externalScripts14 = _this$externalScripts13.rxJs) === null || _this$externalScripts14 === void 0 ? void 0 : _this$externalScripts14.src, (_this$externalScripts15 = this.externalScripts) === null || _this$externalScripts15 === void 0 ? void 0 : (_this$externalScripts16 = _this$externalScripts15.rxJs) === null || _this$externalScripts16 === void 0 ? void 0 : _this$externalScripts16.integrity, (_this$externalScripts17 = this.externalScripts) === null || _this$externalScripts17 === void 0 ? void 0 : (_this$externalScripts18 = _this$externalScripts17.rxJs) === null || _this$externalScripts18 === void 0 ? void 0 : _this$externalScripts18.crossOrigin, (_this$externalScripts19 = this.externalScripts) === null || _this$externalScripts19 === void 0 ? void 0 : (_this$externalScripts20 = _this$externalScripts19.rxJs) === null || _this$externalScripts20 === void 0 ? void 0 : _this$externalScripts20.referrerPolicy) : this.createScriptElement(_defaultLibraryScripts.default.rxJs.src, _defaultLibraryScripts.default.rxJs.integrity, _defaultLibraryScripts.default.rxJs.crossOrigin, _defaultLibraryScripts.default.rxJs.referrerPolicy);
    }
  }, {
    key: "createReactScriptElement",
    value: function createReactScriptElement() {
      var _this$externalScripts21, _this$externalScripts22, _this$externalScripts23, _this$externalScripts24, _this$externalScripts25, _this$externalScripts26, _this$externalScripts27, _this$externalScripts28, _this$externalScripts29, _this$externalScripts30;
      return (_this$externalScripts21 = this.externalScripts) !== null && _this$externalScripts21 !== void 0 && (_this$externalScripts22 = _this$externalScripts21.react) !== null && _this$externalScripts22 !== void 0 && _this$externalScripts22.src ? this.createScriptElement((_this$externalScripts23 = this.externalScripts) === null || _this$externalScripts23 === void 0 ? void 0 : (_this$externalScripts24 = _this$externalScripts23.react) === null || _this$externalScripts24 === void 0 ? void 0 : _this$externalScripts24.src, (_this$externalScripts25 = this.externalScripts) === null || _this$externalScripts25 === void 0 ? void 0 : (_this$externalScripts26 = _this$externalScripts25.react) === null || _this$externalScripts26 === void 0 ? void 0 : _this$externalScripts26.integrity, (_this$externalScripts27 = this.externalScripts) === null || _this$externalScripts27 === void 0 ? void 0 : (_this$externalScripts28 = _this$externalScripts27.react) === null || _this$externalScripts28 === void 0 ? void 0 : _this$externalScripts28.crossOrigin, (_this$externalScripts29 = this.externalScripts) === null || _this$externalScripts29 === void 0 ? void 0 : (_this$externalScripts30 = _this$externalScripts29.react) === null || _this$externalScripts30 === void 0 ? void 0 : _this$externalScripts30.referrerPolicy) : this.createScriptElement(_defaultLibraryScripts.default.react.src);
    }
  }, {
    key: "createReactDomScriptElement",
    value: function createReactDomScriptElement() {
      var _this$externalScripts31, _this$externalScripts32, _this$externalScripts33, _this$externalScripts34, _this$externalScripts35, _this$externalScripts36, _this$externalScripts37, _this$externalScripts38, _this$externalScripts39, _this$externalScripts40, _this$externalScripts41, _this$externalScripts42;
      return (_this$externalScripts31 = this.externalScripts) !== null && _this$externalScripts31 !== void 0 && (_this$externalScripts32 = _this$externalScripts31.reactDom) !== null && _this$externalScripts32 !== void 0 && _this$externalScripts32.src ? this.createScriptElement((_this$externalScripts33 = this.externalScripts) === null || _this$externalScripts33 === void 0 ? void 0 : (_this$externalScripts34 = _this$externalScripts33.reactDom) === null || _this$externalScripts34 === void 0 ? void 0 : _this$externalScripts34.src, (_this$externalScripts35 = this.externalScripts) === null || _this$externalScripts35 === void 0 ? void 0 : (_this$externalScripts36 = _this$externalScripts35.reactDom) === null || _this$externalScripts36 === void 0 ? void 0 : _this$externalScripts36.integrity, (_this$externalScripts37 = this.externalScripts) === null || _this$externalScripts37 === void 0 ? void 0 : (_this$externalScripts38 = _this$externalScripts37.reactDom) === null || _this$externalScripts38 === void 0 ? void 0 : _this$externalScripts38.crossOrigin, (_this$externalScripts39 = this.externalScripts) === null || _this$externalScripts39 === void 0 ? void 0 : (_this$externalScripts40 = _this$externalScripts39.reactDom) === null || _this$externalScripts40 === void 0 ? void 0 : _this$externalScripts40.referrerPolicy) : this.createScriptElement(((_this$externalScripts41 = this.externalScripts) === null || _this$externalScripts41 === void 0 ? void 0 : (_this$externalScripts42 = _this$externalScripts41.reactDom) === null || _this$externalScripts42 === void 0 ? void 0 : _this$externalScripts42.src) ?? _defaultLibraryScripts.default.reactDom.src);
    }
  }, {
    key: "createMarkdownItScriptElement",
    value: function createMarkdownItScriptElement() {
      var _this$externalScripts43, _this$externalScripts44, _this$externalScripts45, _this$externalScripts46, _this$externalScripts47, _this$externalScripts48, _this$externalScripts49, _this$externalScripts50, _this$externalScripts51, _this$externalScripts52;
      return (_this$externalScripts43 = this.externalScripts) !== null && _this$externalScripts43 !== void 0 && (_this$externalScripts44 = _this$externalScripts43.markdownIt) !== null && _this$externalScripts44 !== void 0 && _this$externalScripts44.src ? this.createScriptElement((_this$externalScripts45 = this.externalScripts) === null || _this$externalScripts45 === void 0 ? void 0 : (_this$externalScripts46 = _this$externalScripts45.markdownIt) === null || _this$externalScripts46 === void 0 ? void 0 : _this$externalScripts46.src, (_this$externalScripts47 = this.externalScripts) === null || _this$externalScripts47 === void 0 ? void 0 : (_this$externalScripts48 = _this$externalScripts47.markdownIt) === null || _this$externalScripts48 === void 0 ? void 0 : _this$externalScripts48.integrity, (_this$externalScripts49 = this.externalScripts) === null || _this$externalScripts49 === void 0 ? void 0 : (_this$externalScripts50 = _this$externalScripts49.markdownIt) === null || _this$externalScripts50 === void 0 ? void 0 : _this$externalScripts50.crossOrigin, (_this$externalScripts51 = this.externalScripts) === null || _this$externalScripts51 === void 0 ? void 0 : (_this$externalScripts52 = _this$externalScripts51.markdownIt) === null || _this$externalScripts52 === void 0 ? void 0 : _this$externalScripts52.referrerPolicy) : this.createScriptElement(_defaultLibraryScripts.default.markdownIt.src, _defaultLibraryScripts.default.markdownIt.integrity, _defaultLibraryScripts.default.markdownIt.crossOrigin);
    }
  }, {
    key: "createExternalScriptElements",
    value: function createExternalScriptElements() {
      const webChatScript = this.createWebChatScriptElement();
      const rxJsScript = this.createRxJsScriptElement();
      const reactScript = this.createReactScriptElement();
      const reactDomScript = this.createReactDomScriptElement();
      const markdownItScript = this.createMarkdownItScriptElement();
      const htmlData = `
            ${webChatScript}
            ${rxJsScript}
            ${reactScript}
            ${reactDomScript}
            ${markdownItScript}
        `;
      return htmlData;
    }
  }, {
    key: "createHeadElement",
    value: function createHeadElement() {
      const htmlData = `
            <head>
                ${this.createMetaElement()}
                ${this.createTitleElement()}
                ${this.createExternalScriptElements()}
                <script>
                    function shareObservable(observable) {
                        let observers = [];
                        let subscription;

                        return new Observable(observer => {
                            if (!subscription) {
                                subscription = observable.subscribe({
                                    complete() {
                                        observers.forEach(observer => observer.complete());
                                    },
                                    error(err) {
                                        observers.forEach(observer => observer.error(err));
                                    },
                                    next(value) {
                                        observers.forEach(observer => observer.next(value));
                                    }
                                });
                            }

                            observers.push(observer);

                            return () => {
                                observers = observers.filter(o => o !== observer);

                                if (!observers.length) {
                                    subscription.unsubscribe();
                                    subscription = null;
                                }
                            };
                        });
                    }
                <\/script>
                <script>
                    const messages = ${JSON.stringify(this.options.messages)};
                    const disableMarkdownMessageFormatting = ${this.disableMarkdownMessageFormatting};
                    const disableNewLineMarkdownSupport = ${this.disableNewLineMarkdownSupport};
                <\/script>
                <script>
                    class Translator {
                        static convertTranscriptMessageToActivity(message) {
                            const {created, OriginalMessageId, id, isControlMessage, content, tags, from, attachments, amsMetadata, amsReferences, amsreferences} = message;
                            
                            //it's required to convert the id to a number, otherwise the webchat will not render the messages in the correct order
                            // if the OrginalMessageId is not present, we can use the id as the sequence id, which is always present.
                            
                            const webchatSequenceId = Translator.convertStringValueToInt(OriginalMessageId) || Translator.convertStringValueToInt(id);
                            
                            const activity = {
                                from: {
                                    role: 'bot'
                                },
                                type: 'message'
                            };

                            // Ignore control messages
                            if (isControlMessage) {
                                return false;
                            }

                            if (tags) {
                                const formattedTags = tags.split(',');

                                // Ignore system message
                                if (formattedTags.includes('system')) {
                                    return false;
                                }

                                // Ignore hidden message
                                if (formattedTags.includes('Hidden')) {
                                    return false;
                                }
                            }

                            // Add C1 user display name
                            if (from && from.user && from.user.displayName) {
                                activity.from.name = from.user.displayName;
                            }

                            // Add C2 user display name
                            if (from && from.application && from.application.displayName && from.application.displayName === 'Customer') {
                                activity.from = {
                                    role: 'user',
                                    name: from.application.displayName
                                };
                            }

                            // Attachments
                            if ((amsReferences || amsreferences) && amsMetadata) {
                                const metadata = JSON.parse(amsMetadata);
                                const { fileName } = metadata[0];
                                const text = \`${this.attachmentMessage}\${fileName}\`;

                                if (message.attachments && message.attachments.length > 0 && message.contentUrl) {
                                    activity.attachments = message.attachments;
                                    activity.attachments[0].contentUrl = message.contentUrl;
                                    activity.attachments[0].thumbnailUrl =  message.contentUrl;
                                };

                                return {
                                    ...activity,
                                    text,
                                    timestamp: created,
                                    channelData: { 
                                        "webchat:sequence-id": webchatSequenceId
                                    }
                                }
                            }

                            // Message
                            if (content) {
                                // Adaptive card formatting
                                if (content.includes('"attachments"') || content.includes('"suggestedActions"')) {
                                    try {
                                        const partialActivity = JSON.parse(content);
                                        return {
                                            ...activity,
                                            ...partialActivity,
                                            timestamp: created,
                                            channelData: { 
                                                "webchat:sequence-id": webchatSequenceId
                                            }
                                        };
                                    } catch {

                                    }
                                }
                            }

                            return {
                                ...activity,
                                text: content,
                                timestamp: created,
                                channelData: { 
                                    "webchat:sequence-id": webchatSequenceId
                                }
                            };
                        }
                        
                        static convertStringValueToInt(value) {
                            if (typeof value !== "string" || value === "") {
                                return undefined;
                            }

                            const result = parseInt(value);
                            return isNaN(result) ? undefined : result;
                        }
                    }
                <\/script>
                <script>
                    class TranscriptAdapter {
                        constructor() {
                            this.connectionStatus$ = new window.rxjs.BehaviorSubject(0); // Uninitialized
                            this.activity$ = shareObservable(new Observable((observer) => {
                                this.activityObserver = observer;

                                this.connectionStatus$.next(1); // Connecting
                                this.connectionStatus$.next(2); // Online

                                // Retrieve messages
                                if (messages) {
                                    setTimeout(() => { // setTimeout is needed due to some WebChat issues
                                        messages.map((message) => {
                                            this.activityObserver.next({
                                                ...Translator.convertTranscriptMessageToActivity(message),
                                                type: 'message'
                                            });
                                        });
                                    }, 1);
                                }
                            }));
                        }
                    }
                <\/script>
                <style>
                    body {
                        margin: 0;
                    }

                    .message-name {
                        font-family: Segoe UI,SegoeUI,Helvetica Neue,Helvetica,Arial,sans-serif;
                        font-weight: 700;
                        font-size: 10px;
                    }

                    .message-timestamp {
                        font-family: Segoe UI,SegoeUI,Helvetica Neue,Helvetica,Arial,sans-serif;
                        font-weight: 500;
                        font-size: 10px;
                    }

                    .avatar {
                        width: 40px;
                        height: 40px;
                        border-radius: 50%;
                        text-align: center;
                    }

                    .avatar--bot {
                        background-color: ${this.agentAvatarBackgroundColor};
                    }

                    .avatar--user {
                        background-color: ${this.customerAvatarBackgroundColor};
                    }

                    .avatar > p {
                        font-weight: 600;
                        text-align: center;
                        line-height: 0.5;
                        font-family: "Segoe UI", Arial, sans-serif;
                    }

                    .avatar--bot > p {
                        color: ${this.agentAvatarFontColor};
                    }

                    .avatar--user > p {
                        color: ${this.customerAvatarFontColor};
                    }

                    .webchat__bubble__content>div.ms_lcw_webchat_adaptive_card {
                        background-color: #FFF;
                    }

                    div[class="ac-textBlock"] {
                        color: #000 !important;
                    }

                    .ms_lcw_webchat_received_message a:link, .ms_lcw_webchat_received_message a:visited, .ms_lcw_webchat_received_message a:hover, .ms_lcw_webchat_received_message a:active {
                        color: #FFF;
                    }
                <\/style>
            </head>
        `;
      return htmlData;
    }
  }, {
    key: "createBodyElement",
    value: function createBodyElement() {
      const htmlData = `
            <body>
                <script>
                    if (!navigator.onLine) {
                        const offlineText = \`${this.networkOfflineMessage}\`;
                        document.body.innerHTML = offlineText;
                    }

                    window.addEventListener("online", () => {
                        document.body.innerHTML = \`${this.networkOnlineMessage} <button onclick="window.location.reload()"> Refresh </button>\`;
                    });

                    document.addEventListener("copy", (event) => {
                        const clonedSelectedContent = window.getSelection().getRangeAt(0).cloneContents();
                        const copiedContent = document.createElement("div");
                        copiedContent.appendChild(clonedSelectedContent);
        
                        event.clipboardData.setData("text/plain", getAllText(copiedContent));
                        event.preventDefault();
                    });


                    getAllText = (element) => {
                        let plainText = "";
                        Array.from(element.childNodes).forEach((node) => {
                            // ignore aria-hidden elements and keyboard help text
                            const ariaHiddenAttr = node.attributes ? node.attributes.getNamedItem("aria-hidden") : null;
                            if ((ariaHiddenAttr && ariaHiddenAttr.value === "true") || node.classList && node.classList.contains("webchat__keyboard-help")) {
                                return;
                            }
                         
                            // get all texts inside activity body, including message, translated message, attachment name, adaptive card content, status footer, etc.
                            if (node.classList && node.classList.contains("webchat__basic-transcript__activity-body")) {
                                plainText += this.processTranscriptActivityNode(node);
                                return;
                            }
                            if (node.nodeType === Node.TEXT_NODE) {
                                plainText += node.textContent + '\\n';
                            } else {
                                plainText += this.getAllText(node);
                            }
                        });
                        return plainText;
                    }

                    processTranscriptActivityNode = (node) => {
                        const divs = node.getElementsByTagName("div");
                        let plainText = "";
                
                        if (divs && divs.length > 1 && divs[1]) {                           
                            const messageRow = node.querySelector(".webchat__stacked-layout__message-row[aria-roledescription='message']");
                            const author = node.querySelector(".message-name");
                            const attachmentRow = node.querySelector(".webchat__stacked-layout__attachment-row[aria-roledescription='attachment']");
                        
                            if (messageRow) {
                                let message = messageRow.getElementsByClassName("webchat__text-content__markdown");
                                
                                if (message.length === 0) {
                                    message = messageRow.getElementsByClassName("markdown");                                    
                                }

                                if (message.length > 0) {
                                    plainText += author.textContent + '\\n' + message[0].textContent + '\\n';
                                }
                            }  else if (attachmentRow) {
                                const attachment = attachmentRow.getElementsByClassName("webchat__fileContent__fileName");
                                const adaptiveCard = this.getAdaptiveCardContent(attachmentRow.querySelector(".ac-container.ac-adaptiveCard"));
                               
                                plainText += attachment && attachment.length > 0 ? author.textContent +'\\n' + attachment[0].textContent +'\\n': author.textContent +'\\n' + adaptiveCard +'\\n';
                            }
                
                            const statusElements = node.getElementsByClassName("webchat__stacked-layout__status");
                            if (statusElements.length > 0) {
                                const timestampelement = statusElements[0].querySelector(".message-timestamp");
                                plainText += timestampelement ? timestampelement.textContent+'\\n\\n' : '\\n';
                            }
                        }
                
                        return plainText;
                    }

                    getAdaptiveCardContent = (node) => {
                        if (!node) {
                            return undefined;
                        }

                        let plainText = "";
                        const rows = node.querySelectorAll(".ac-textBlock p");
                        rows.forEach((row) => {
                            plainText += row.textContent+ '\\n';
                        });

                        return plainText;
                    }

                <\/script>
                <div id="transcript"></div>
                <script>
                    const getIconText = (text) => {
                        if (text) {
                            const initials = text.split(/\\s/).reduce((response, word) => response += word.slice(0, 1), '');
                            if (initials.length > 1) {
                                return initials.substring(0, 2).toUpperCase();
                            } else {
                                return text.substring(0, 2).toUpperCase();
                            }
                        }

                        return "";
                    }

                    const activityMiddleware = () => (next) => (...args) => {
                        const [card] = args;

                        if (card.activity) {
                            if (card.activity.from && card.activity.from.role === "channel") {
                                return () => false;
                            }

                            // Incoming text message
                            if (card.activity.text && card.activity.from && card.activity.from.role !== "user") {
                                return (...renderArgs) => (React.createElement(
                                    'div',
                                    {className: 'ms_lcw_webchat_received_message'},
                                    next(...args)(...renderArgs)
                                ))
                            }
                        }

                        return next(...args);
                    };

                    const activityStatusMiddleware = () => (next) => (...args) => {
                        const [card] = args;
                        const {activity} = card;

                        if (activity) {
                            const {from, timestamp} = activity;

                            const nameElement = React.createElement(
                                'span',
                                {className: 'message-name'},
                                from.name
                            );

                            const formattedDate = new Date(timestamp);
                            const formattedTimeString = formattedDate.toLocaleTimeString("en-us", { year: "numeric", month:"numeric", day:"numeric", hour: "2-digit", minute: "2-digit"});

                            const timestampElement = React.createElement(
                                'span',
                                {className: 'message-timestamp'},
                                formattedTimeString
                            );

                            return from.name && timestamp && React.createElement('span', null, nameElement, ' - ', timestampElement)
                        }

                        return next(...args);
                    };

                    const avatarMiddleware = () => (next) => (...args) => {
                        const [card] = args;
                        const {fromUser, activity} = card;
                        let displayName = getIconText(activity.from.name);
                        let customerDisplayName = '${this.customerDisplayName}';

                        if (fromUser && customerDisplayName) {
                            displayName = customerDisplayName;
                        }

                        const avatarElement = React.createElement(
                            "div",
                            {className: fromUser? "avatar avatar--user": "avatar avatar--bot"},
                            React.createElement(
                                "p",
                                null,
                                \`\${displayName}\`
                            )
                        );

                        return avatarElement;
                    }

                    const attachmentMiddleware = () => (next) => (...args) => {
                        const [card] = args;
                        const {activity} = card;

                        if (activity) {
                            const { activity: { attachments }, attachment } = card;

                            // No attachment
                            if (!attachments || !attachments.length || !attachment) {
                                return next(...args);
                            }

                            let { content, contentType } = attachment || { content: "", contentType: "" };

                            // Adaptive card
                            if (contentType.startsWith("application/vnd.microsoft.card")) {
                                const adaptiveCardElement = React.createElement(
                                    "div",
                                    {className: 'ms_lcw_webchat_adaptive_card'},
                                    next(...args)
                                );

                                return adaptiveCardElement;
                            }
                        }

                        return next(...args);
                    }

                    const createMarkdown = (disableMarkdownMessageFormatting, disableNewLineMarkdownSupport) => {
                        let markdown;
                        if (!disableMarkdownMessageFormatting) {
                            markdown = new window.markdownit(
                                "default",
                                {
                                    html: true,
                                    linkify: true,
                                    breaks: (!disableNewLineMarkdownSupport)
                                }
                            );
                        } else {
                            markdown = new window.markdownit(
                                "zero",
                                {
                                    html: true,
                                    linkify: true,
                                    breaks: (!disableNewLineMarkdownSupport)
                                }
                            );

                            markdown.enable([
                                "entity",
                                "linkify",
                                "html_block",
                                "html_inline",
                                "newline"
                            ]);
                        }

                        return markdown;
                    };

                    const markdown = createMarkdown(disableMarkdownMessageFormatting, disableNewLineMarkdownSupport);
                    const renderMarkdown = (text) => {
                        const render = disableNewLineMarkdownSupport? markdown.renderInline.bind(markdown): markdown.render.bind(markdown);
                        text = render(text);
                        return text;
                    };

                    const adapter = new TranscriptAdapter();
                    const styleOptions = {
                        hideSendBox: true,
                        backgroundColor: '${this.transcriptBackgroundColor}',
                        bubbleBackground: '${this.agentAvatarBackgroundColor}',
                        bubbleTextColor: '${this.agentAvatarFontColor}',
                        bubbleBorderRadius: 12,
                        bubbleNubSize: 1,
                        bubbleFromUserBackground: '${this.customerAvatarBackgroundColor}',
                        bubbleFromUserTextColor: '${this.customerAvatarFontColor}',
                        bubbleFromUserBorderRadius: 12,
                        bubbleFromUserNubSize: 1,
                        botAvatarInitials: 'C1',
                        userAvatarInitials: 'C2'
                    };

                    window.WebChat.renderWebChat({
                        directLine: adapter,
                        styleOptions,
                        activityMiddleware,
                        activityStatusMiddleware,
                        avatarMiddleware,
                        attachmentMiddleware,
                        renderMarkdown
                    },
                    document.getElementById('transcript'));
                <\/script>
            </body>
        `;
      return htmlData;
    }
  }, {
    key: "createHTML",
    value: function createHTML() {
      const htmlData = `
            <html>
                ${this.createHeadElement()}
                ${this.createBodyElement()}
            </html>
        `;
      return htmlData;
    }
  }]);
  return TranscriptHTMLBuilder;
}();
const createChatTranscript = async function (transcript, facadeChatSDK) {
  let renderAttachments = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  let transcriptOptions = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};
  // eslint-disable-line @typescript-eslint/no-explicit-any
  const transcriptMessages = JSON.parse(transcript);
  const convertBlobToBase64 = async blob => {
    return new Promise(resolve => {
      const reader = new FileReader();
      reader.onloadend = () => resolve(reader.result);
      reader.readAsDataURL(blob);
    });
  };
  let messages = transcriptMessages.filter(message => {
    message.content = _dompurify.default.sanitize(message.content);
    return message;
  });
  if (renderAttachments) {
    messages = await Promise.all(transcriptMessages.map(async message => {
      // eslint-disable-line @typescript-eslint/no-explicit-any
      const {
        amsReferences = message.amsreferences,
        amsMetadata
      } = message;
      if (amsReferences && amsMetadata) {
        const references = JSON.parse(amsReferences);
        const metadata = JSON.parse(amsMetadata);
        const fileMetadata = {
          id: references[0],
          type: metadata[0].contentType
        };
        const blob = await facadeChatSDK.downloadFileAttachment(fileMetadata);
        const base64 = await convertBlobToBase64(blob);
        message.contentUrl = base64;
      }
      return message;
    }));
  }
  const options = {
    ...transcriptOptions,
    messages
  };
  const htmlBuilder = new TranscriptHTMLBuilder(options);
  const text = htmlBuilder.createHTML();
  const fileName = `${transcriptOptions.fileName || "transcript"}.html`;
  (0, _utils.createFileAndDownload)(fileName, text, "text/html");
};
var _default = createChatTranscript;
exports.default = _default;