function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var ScenarioState;
(function (ScenarioState) {
  ScenarioState["Start"] = "STARTED";
  ScenarioState["Fail"] = "FAILED";
  ScenarioState["Complete"] = "COMPLETED";
  ScenarioState["Warn"] = "WARN";
})(ScenarioState || (ScenarioState = {}));
function formatScenario(state, event) {
  return `SCENARIO_${state}: Scenario_${event}`;
}
let ScenarioMarker = /*#__PURE__*/function () {
  function ScenarioMarker() {
    _classCallCheck(this, ScenarioMarker);
  }
  _createClass(ScenarioMarker, null, [{
    key: "startScenario",
    value:
    /**
    * Formats the event name for the "Started" state of a scenario.
    */
    function startScenario(event) {
      return formatScenario(ScenarioState.Start, event);
    }

    /**
    * Formats the event name for the "Failed" state of a scenario.
    */
  }, {
    key: "failScenario",
    value: function failScenario(event) {
      return formatScenario(ScenarioState.Fail, event);
    }

    /**
    * Formats the event name for the "Completed" state of a scenario.
    */
  }, {
    key: "completeScenario",
    value: function completeScenario(event) {
      return formatScenario(ScenarioState.Complete, event);
    }

    /**
    * Formats the event name for the "Warn" state of a scenario.
    */
  }, {
    key: "warnScenario",
    value: function warnScenario(event) {
      return formatScenario(ScenarioState.Warn, event);
    }
  }]);
  return ScenarioMarker;
}();
export default ScenarioMarker;