function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import { DefaultActivitySubscriber } from "./ActivitySubscriber/DefaultActivitySubscriber";
import { shareObservable } from "./shareObservable";
export let ChatAdapterShim = /*#__PURE__*/function () {
  // eslint-disable-next-line @typescript-eslint/no-explicit-any

  // eslint-disable-next-line @typescript-eslint/no-explicit-any

  // eslint-disable-next-line @typescript-eslint/no-explicit-any

  // eslint-disable-next-line @typescript-eslint/no-explicit-any
  function ChatAdapterShim(chatAdapter) {
    _classCallCheck(this, ChatAdapterShim);
    _defineProperty(this, "chatAdapter", void 0);
    _defineProperty(this, "activityObserver", void 0);
    _defineProperty(this, "subscribers", void 0);
    this.subscribers = [];
    this.chatAdapter = {
      ...chatAdapter,
      activity$: shareObservable(
      // eslint-disable-next-line @typescript-eslint/no-explicit-any
      new window.Observable(observer => {
        this.activityObserver = observer;
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        const abortController = new window.AbortController();
        (async () => {
          try {
            // eslint-disable-next-line @typescript-eslint/no-explicit-any
            for await (let activity of chatAdapter.activities({
              signal: abortController.signal
            })) {
              for (const subscriber of [...this.subscribers, new DefaultActivitySubscriber()]) {
                subscriber.observer = this.activityObserver;
                activity = await subscriber.next(activity);
                if (!activity) {
                  break;
                }
              }
            }
            observer.complete();
          } catch (error) {
            observer.error(error);
          }
        })();
        return () => {
          abortController.abort();
        };
      }))
    };
  }

  // eslint-disable-next-line @typescript-eslint/no-explicit-any
  _createClass(ChatAdapterShim, [{
    key: "addSubscriber",
    value: function addSubscriber(subscriber) {
      this.subscribers.push(subscriber);
    }
  }]);
  return ChatAdapterShim;
}();