import { LogLevel, TelemetryEvent } from "../../../common/telemetry/TelemetryConstants";
import { TelemetryHelper } from "../../../common/telemetry/TelemetryHelper";

// eslint-disable-next-line @typescript-eslint/no-explicit-any
export const initCallingSdk = async (facadeChatSDK, setVoiceVideoCallingSDK) => {
  try {
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    if (facadeChatSDK.getChatSDK().getVoiceVideoCalling) {
      // eslint-disable-next-line @typescript-eslint/no-explicit-any
      const callingSDK = await facadeChatSDK.getChatSDK().getVoiceVideoCalling();
      setVoiceVideoCallingSDK(callingSDK);
      TelemetryHelper.logCallingEvent(LogLevel.INFO, {
        Event: TelemetryEvent.CallingSDKLoadSuccess
      });
      return true;
    }
    return false;
  } catch (error) {
    TelemetryHelper.logCallingEvent(LogLevel.ERROR, {
      Event: TelemetryEvent.CallingSDKLoadFailed,
      ExceptionDetails: {
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        exception: error.message
      }
    });
    return false;
  }
};