function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import DOMPurify from "dompurify";
import { HtmlAttributeNames } from "../../../../common/Constants";
let HyperlinkTextOverrideRenderer = /*#__PURE__*/function () {
  function HyperlinkTextOverrideRenderer(hyperlinkTextOverride) {
    _classCallCheck(this, HyperlinkTextOverrideRenderer);
    _defineProperty(this, "hyperlinkTextOverride", void 0);
    this.hyperlinkTextOverride = hyperlinkTextOverride;
  }
  _createClass(HyperlinkTextOverrideRenderer, [{
    key: "convertTextToHtmlNode",
    value: function convertTextToHtmlNode(text) {
      const htmlNode = document.createElement(HtmlAttributeNames.div);
      try {
        text = DOMPurify.sanitize(text, {
          ADD_ATTR: ["target"]
        });
        htmlNode.innerHTML = text;
      } catch {
        return htmlNode;
      }
      return htmlNode;
    }
  }, {
    key: "processANode",
    value: function processANode(htmlNode) {
      // eslint-disable-line @typescript-eslint/no-explicit-any
      const aTags = htmlNode.getElementsByTagName(HtmlAttributeNames.aTagName);
      for (let index = 0; index < aTags.length; index++) {
        const aNode = aTags[index];
        if (!aNode || !aNode.tagName || aNode.tagName.toLowerCase() !== HtmlAttributeNames.aTagName || !aNode.href) continue;
        if (aNode.href !== aNode.text.trim()) {
          aNode.text = aNode.href;
        }
      }
    }
  }, {
    key: "applicable",
    value: function applicable(text) {
      if (!this.hyperlinkTextOverride) {
        return false;
      }
      try {
        const htmlNode = this.convertTextToHtmlNode(text);
        const aNodes = htmlNode.getElementsByTagName(HtmlAttributeNames.aTagName);
        return !!aNodes && aNodes.length && aNodes.length > 0;
      } catch {
        return false;
      }
    }
  }, {
    key: "render",
    value: function render(text) {
      if (!this.applicable(text)) {
        return text;
      }
      const htmlNode = this.convertTextToHtmlNode(text);
      this.processANode(htmlNode);
      text = htmlNode.innerHTML;
      return text;
    }
  }]);
  return HyperlinkTextOverrideRenderer;
}();
export default HyperlinkTextOverrideRenderer;