import React from "react";
import { NotificationScenarios } from "../../enums/NotificationScenarios";
import NotificationPaneStateful from "../../../../notificationpanestateful/NotificationPaneStateful";

// eslint-disable-next-line @typescript-eslint/no-explicit-any
export const createToastMiddleware = (notificationPaneProps, endChat) => {
  // eslint-disable-next-line @typescript-eslint/no-explicit-any, react/display-name
  const toastMiddleware = () => next => card => {
    const {
      notification
    } = card;
    if (notificationPaneProps) {
      if (notification.id === NotificationScenarios.ChatDisconnect) {
        return /*#__PURE__*/React.createElement(NotificationPaneStateful, {
          notificationPaneProps: notificationPaneProps,
          notificationScenarioType: NotificationScenarios.ChatDisconnect,
          endChat: endChat
        });
      }

      // TODO: additional notification scenarios to be added...
    }

    return next(card);
  };
  return toastMiddleware;
};