/******
 * ChannelDataMiddleware
 * 
 * Adds necessary tags if not present so that the rendering middlewares can process them later.
 ******/

import { Constants } from "../../../../../common/Constants";
import { DeliveryMode } from "@microsoft/omnichannel-chat-sdk";
import { WebChatActionType } from "../../enums/WebChatActionType";

// eslint-disable-next-line @typescript-eslint/no-explicit-any, @typescript-eslint/no-unused-vars
const channelDataMiddleware = _ref => {
  let {
    dispatch
  } = _ref;
  return next => action => {
    var _action$payload, _action$payload$activ;
    if ((action === null || action === void 0 ? void 0 : action.type) === WebChatActionType.DIRECT_LINE_POST_ACTIVITY_PENDING && action !== null && action !== void 0 && (_action$payload = action.payload) !== null && _action$payload !== void 0 && (_action$payload$activ = _action$payload.activity) !== null && _action$payload$activ !== void 0 && _action$payload$activ.channelData) {
      const channelIdTag = `${Constants.channelIdKey}${Constants.ChannelId}`;
      const customerMessageTag = `${Constants.CustomerTag}`;
      if (action.payload.activity.channelData.tags) {
        if (!action.payload.activity.channelData.tags.includes(channelIdTag)) {
          action.payload.activity.channelData.tags.push(channelIdTag);
        }
        if (!action.payload.activity.channelData.tags.includes(customerMessageTag)) {
          action.payload.activity.channelData.tags.push(customerMessageTag);
        }
      } else {
        action.payload.activity.channelData.tags = [channelIdTag];
        action.payload.activity.channelData.tags.push(customerMessageTag);
      }
      action.payload.activity.channelData.metadata = {
        deliveryMode: DeliveryMode.Bridged
      };
    }
    return next(action);
  };
};
export default channelDataMiddleware;