/* eslint-disable indent */

import { LiveChatWidgetActionType } from "./common/LiveChatWidgetActionType";
export const createReducer = () => {
  return reducer;
};
export const executeReducer = (state, action) => {
  return reducer(state, action);
};

// inMemory state to store the runtime state of the widget for access immediately
let inMemory;
const reducer = (state, action) => {
  var _action$payload, _action$payload2, _action$payload3, _action$payload4, _action$payload5, _action$payload6;
  // Initialize inMemory state
  if (!inMemory) {
    inMemory = state;
  }
  switch (action.type) {
    case LiveChatWidgetActionType.SET_WIDGET_ELEMENT_ID:
      inMemory = {
        ...inMemory,
        domainStates: {
          ...inMemory.domainStates,
          widgetElementId: action.payload
        }
      };
      return {
        ...state,
        domainStates: {
          ...state.domainStates,
          widgetElementId: action.payload
        }
      };
    case LiveChatWidgetActionType.SET_RENDERING_MIDDLEWARE_PROPS:
      inMemory = {
        ...inMemory,
        domainStates: {
          ...inMemory.domainStates,
          renderingMiddlewareProps: action.payload
        }
      };
      return {
        ...state,
        domainStates: {
          ...state.domainStates,
          renderingMiddlewareProps: action.payload
        }
      };
    case LiveChatWidgetActionType.SET_MIDDLEWARE_LOCALIZED_TEXTS:
      inMemory = {
        ...inMemory,
        domainStates: {
          ...inMemory.domainStates,
          middlewareLocalizedTexts: action.payload
        }
      };
      return {
        ...state,
        domainStates: {
          ...state.domainStates,
          middlewareLocalizedTexts: action.payload
        }
      };
    case LiveChatWidgetActionType.SET_GLOBAL_DIR:
      inMemory = {
        ...inMemory,
        domainStates: {
          ...inMemory.domainStates,
          globalDir: action.payload === "ltr" || action.payload === "rtl" ? action.payload : "ltr"
        }
      };
      return {
        ...state,
        domainStates: {
          ...state.domainStates,
          globalDir: action.payload === "ltr" || action.payload === "rtl" ? action.payload : "ltr"
        }
      };
    case LiveChatWidgetActionType.SET_MINIMIZED:
      inMemory = {
        ...inMemory,
        appStates: {
          ...inMemory.appStates,
          isMinimized: action.payload
        }
      };
      return {
        ...state,
        appStates: {
          ...state.appStates,
          isMinimized: action.payload
        }
      };
    case LiveChatWidgetActionType.SET_CONVERSATION_STATE:
      inMemory = {
        ...inMemory,
        appStates: {
          ...inMemory.appStates,
          conversationState: action.payload
        }
      };
      return {
        ...state,
        appStates: {
          ...state.appStates,
          conversationState: action.payload
        }
      };
    case LiveChatWidgetActionType.SET_START_CHAT_FAILING:
      inMemory = {
        ...inMemory,
        appStates: {
          ...inMemory.appStates,
          startChatFailed: action.payload
        }
      };
      return {
        ...state,
        appStates: {
          ...state.appStates,
          startChatFailed: action.payload
        }
      };
    case LiveChatWidgetActionType.SET_START_CHAT_FAILURE_TYPE:
      inMemory = {
        ...inMemory,
        domainStates: {
          ...inMemory.domainStates,
          startChatFailureType: action.payload
        }
      };
      return {
        ...state,
        domainStates: {
          ...state.domainStates,
          startChatFailureType: action.payload
        }
      };
    case LiveChatWidgetActionType.SET_OUTSIDE_OPERATING_HOURS:
      inMemory = {
        ...inMemory,
        appStates: {
          ...inMemory.appStates,
          outsideOperatingHours: action.payload
        }
      };
      return {
        ...state,
        appStates: {
          ...state.appStates,
          outsideOperatingHours: action.payload
        }
      };
    case LiveChatWidgetActionType.SET_PRE_CHAT_SURVEY_RESPONSE:
      inMemory = {
        ...inMemory,
        domainStates: {
          ...inMemory.domainStates,
          preChatSurveyResponse: action.payload
        }
      };
      return {
        ...state,
        domainStates: {
          ...state.domainStates,
          preChatSurveyResponse: action.payload
        }
      };
    case LiveChatWidgetActionType.SET_CUSTOM_CONTEXT:
      inMemory = {
        ...inMemory,
        domainStates: {
          ...inMemory.domainStates,
          // eslint-disable-next-line @typescript-eslint/no-explicit-any
          customContext: action.payload
        }
      };
      return {
        ...state,
        domainStates: {
          ...state.domainStates,
          // eslint-disable-next-line @typescript-eslint/no-explicit-any
          customContext: action.payload
        }
      };
    case LiveChatWidgetActionType.SET_PREVIOUS_FOCUSED_ELEMENT_ID:
      inMemory = {
        ...inMemory,
        appStates: {
          ...inMemory.appStates,
          previousElementIdOnFocusBeforeModalOpen: action.payload
        }
      };
      return {
        ...state,
        appStates: {
          ...state.appStates,
          previousElementIdOnFocusBeforeModalOpen: action.payload
        }
      };
    case LiveChatWidgetActionType.SET_SHOW_CONFIRMATION:
      inMemory = {
        ...inMemory,
        uiStates: {
          ...inMemory.uiStates,
          showConfirmationPane: action.payload
        }
      };
      return {
        ...state,
        uiStates: {
          ...state.uiStates,
          showConfirmationPane: action.payload
        }
      };
    case LiveChatWidgetActionType.SET_POST_CHAT_CONTEXT:
      inMemory = {
        ...inMemory,
        domainStates: {
          ...inMemory.domainStates,
          // eslint-disable-next-line @typescript-eslint/no-explicit-any
          postChatContext: action.payload
        }
      };
      return {
        ...state,
        domainStates: {
          ...state.domainStates,
          // eslint-disable-next-line @typescript-eslint/no-explicit-any
          postChatContext: action.payload
        }
      };
    case LiveChatWidgetActionType.SHOW_CALLING_CONTAINER:
      inMemory = {
        ...inMemory,
        uiStates: {
          ...inMemory.uiStates,
          showCallingPopup: action.payload
        }
      };
      return {
        ...state,
        uiStates: {
          ...state.uiStates,
          showCallingPopup: action.payload
        }
      };
    case LiveChatWidgetActionType.SET_INCOMING_CALL:
      inMemory = {
        ...inMemory,
        uiStates: {
          ...inMemory.uiStates,
          isIncomingCall: action.payload
        }
      };
      return {
        ...state,
        uiStates: {
          ...state.uiStates,
          isIncomingCall: action.payload
        }
      };
    case LiveChatWidgetActionType.SET_FOCUS_CHAT_BUTTON:
      inMemory = {
        ...inMemory,
        uiStates: {
          ...inMemory.uiStates,
          focusChatButton: action.payload
        }
      };
      return {
        ...state,
        uiStates: {
          ...state.uiStates,
          focusChatButton: action.payload
        }
      };
    case LiveChatWidgetActionType.DISABLE_VIDEO_CALL:
      inMemory = {
        ...inMemory,
        uiStates: {
          ...inMemory.uiStates,
          disableVideoCall: action.payload
        }
      };
      return {
        ...state,
        uiStates: {
          ...state.uiStates,
          disableVideoCall: action.payload
        }
      };
    case LiveChatWidgetActionType.DISABLE_LOCAL_VIDEO:
      inMemory = {
        ...inMemory,
        uiStates: {
          ...inMemory.uiStates,
          disableSelfVideo: action.payload
        }
      };
      return {
        ...state,
        uiStates: {
          ...state.uiStates,
          disableSelfVideo: action.payload
        }
      };
    case LiveChatWidgetActionType.DISABLE_REMOTE_VIDEO:
      inMemory = {
        ...inMemory,
        uiStates: {
          ...inMemory.uiStates,
          disableRemoteVideo: action.payload
        }
      };
      return {
        ...state,
        uiStates: {
          ...state.uiStates,
          disableRemoteVideo: action.payload
        }
      };
    case LiveChatWidgetActionType.SET_CHAT_TOKEN:
      inMemory = {
        ...inMemory,
        domainStates: {
          ...inMemory.domainStates,
          // eslint-disable-next-line @typescript-eslint/no-explicit-any
          chatToken: action.payload
        }
      };
      return {
        ...state,
        domainStates: {
          ...state.domainStates,
          // eslint-disable-next-line @typescript-eslint/no-explicit-any
          chatToken: action.payload
        }
      };
    case LiveChatWidgetActionType.SET_SHOW_EMAIL_TRANSCRIPT_PANE:
      inMemory = {
        ...inMemory,
        uiStates: {
          ...inMemory.uiStates,
          showEmailTranscriptPane: action.payload
        }
      };
      return {
        ...state,
        uiStates: {
          ...state.uiStates,
          showEmailTranscriptPane: action.payload
        }
      };
    case LiveChatWidgetActionType.SET_PRECHAT_RESPONSE_EMAIL:
      inMemory = {
        ...inMemory,
        appStates: {
          ...inMemory.appStates,
          preChatResponseEmail: action.payload
        }
      };
      return {
        ...state,
        appStates: {
          ...state.appStates,
          preChatResponseEmail: action.payload
        }
      };
    case LiveChatWidgetActionType.SET_AUDIO_NOTIFICATION:
      inMemory = {
        ...inMemory,
        appStates: {
          ...inMemory.appStates,
          isAudioMuted: action.payload
        }
      };
      return {
        ...state,
        appStates: {
          ...state.appStates,
          isAudioMuted: action.payload
        }
      };
    case LiveChatWidgetActionType.SET_E2VV_ENABLED:
      inMemory = {
        ...inMemory,
        appStates: {
          ...inMemory.appStates,
          e2vvEnabled: action.payload
        }
      };
      return {
        ...state,
        appStates: {
          ...state.appStates,
          e2vvEnabled: action.payload
        }
      };
    case LiveChatWidgetActionType.SET_START_CHAT_BUTTON_DISPLAY:
      inMemory = {
        ...inMemory,
        appStates: {
          ...inMemory.appStates,
          hideStartChatButton: action.payload
        }
      };
      return {
        ...state,
        appStates: {
          ...state.appStates,
          hideStartChatButton: action.payload
        }
      };
    case LiveChatWidgetActionType.SET_PROACTIVE_CHAT_PARAMS:
      inMemory = {
        ...inMemory,
        appStates: {
          ...inMemory.appStates,
          proactiveChatStates: {
            ...state.appStates.proactiveChatStates,
            proactiveChatBodyTitle: (_action$payload = action.payload) === null || _action$payload === void 0 ? void 0 : _action$payload.proactiveChatBodyTitle,
            proactiveChatEnablePrechat: (_action$payload2 = action.payload) === null || _action$payload2 === void 0 ? void 0 : _action$payload2.proactiveChatEnablePrechat,
            proactiveChatInNewWindow: (_action$payload3 = action.payload) === null || _action$payload3 === void 0 ? void 0 : _action$payload3.proactiveChatInNewWindow
          }
        }
      };
      return {
        ...state,
        appStates: {
          ...state.appStates,
          proactiveChatStates: {
            ...state.appStates.proactiveChatStates,
            proactiveChatBodyTitle: (_action$payload4 = action.payload) === null || _action$payload4 === void 0 ? void 0 : _action$payload4.proactiveChatBodyTitle,
            proactiveChatEnablePrechat: (_action$payload5 = action.payload) === null || _action$payload5 === void 0 ? void 0 : _action$payload5.proactiveChatEnablePrechat,
            proactiveChatInNewWindow: (_action$payload6 = action.payload) === null || _action$payload6 === void 0 ? void 0 : _action$payload6.proactiveChatInNewWindow
          }
        }
      };
    case LiveChatWidgetActionType.SET_TELEMETRY_DATA:
      inMemory = {
        ...inMemory,
        domainStates: {
          ...inMemory.domainStates,
          telemetryInternalData: action.payload
        }
      };
      return {
        ...state,
        domainStates: {
          ...state.domainStates,
          telemetryInternalData: action.payload
        }
      };
    case LiveChatWidgetActionType.SET_RECONNECT_ID:
      inMemory = {
        ...inMemory,
        appStates: {
          ...inMemory.appStates,
          reconnectId: action.payload
        }
      };
      return {
        ...state,
        appStates: {
          ...state.appStates,
          reconnectId: action.payload
        }
      };
    case LiveChatWidgetActionType.SET_UNREAD_MESSAGE_COUNT:
      inMemory = {
        ...inMemory,
        appStates: {
          ...inMemory.appStates,
          unreadMessageCount: action.payload
        }
      };
      return {
        ...state,
        appStates: {
          ...state.appStates,
          unreadMessageCount: action.payload
        }
      };
    case LiveChatWidgetActionType.SET_LIVE_CHAT_CONTEXT:
      inMemory = {
        ...inMemory,
        domainStates: {
          ...inMemory.domainStates,
          // eslint-disable-next-line @typescript-eslint/no-explicit-any
          liveChatContext: action.payload
        }
      };
      return {
        ...state,
        domainStates: {
          ...state.domainStates,
          // eslint-disable-next-line @typescript-eslint/no-explicit-any
          liveChatContext: action.payload
        }
      };
    case LiveChatWidgetActionType.SET_WIDGET_STATE:
      inMemory = {
        ...action.payload
      };
      return {
        ...action.payload
      };
    case LiveChatWidgetActionType.SET_CONVERSATION_ENDED_BY:
      inMemory = {
        ...inMemory,
        appStates: {
          ...inMemory.appStates,
          conversationEndedBy: action.payload
        }
      };
      return {
        ...state,
        appStates: {
          ...state.appStates,
          conversationEndedBy: action.payload
        }
      };
    case LiveChatWidgetActionType.SET_WIDGET_SIZE:
      inMemory = {
        ...inMemory,
        domainStates: {
          ...inMemory.domainStates,
          // eslint-disable-next-line @typescript-eslint/no-explicit-any
          widgetSize: action.payload
        }
      };
      return {
        ...state,
        domainStates: {
          ...state.domainStates,
          // eslint-disable-next-line @typescript-eslint/no-explicit-any
          widgetSize: action.payload
        }
      };
    case LiveChatWidgetActionType.SET_WIDGET_INSTANCE_ID:
      inMemory = {
        ...inMemory,
        domainStates: {
          ...inMemory.domainStates,
          // eslint-disable-next-line @typescript-eslint/no-explicit-any
          widgetInstanceId: action.payload
        }
      };
      return {
        ...state,
        domainStates: {
          ...state.domainStates,
          // eslint-disable-next-line @typescript-eslint/no-explicit-any
          widgetInstanceId: action.payload
        }
      };
    case LiveChatWidgetActionType.SET_LIVE_CHAT_CONFIG:
      inMemory = {
        ...inMemory,
        domainStates: {
          ...inMemory.domainStates,
          // eslint-disable-next-line @typescript-eslint/no-explicit-any
          liveChatConfig: action.payload
        }
      };
      return {
        ...state,
        domainStates: {
          ...state.domainStates,
          // eslint-disable-next-line @typescript-eslint/no-explicit-any
          liveChatConfig: action.payload
        }
      };
    case LiveChatWidgetActionType.SET_INITIAL_CHAT_SDK_REQUEST_ID:
      inMemory = {
        ...inMemory,
        domainStates: {
          ...inMemory.domainStates,
          initialChatSdkRequestId: action.payload
        }
      };
      return {
        ...state,
        domainStates: {
          ...state.domainStates,
          initialChatSdkRequestId: action.payload
        }
      };
    case LiveChatWidgetActionType.SET_CHAT_DISCONNECT_EVENT_RECEIVED:
      inMemory = {
        ...inMemory,
        appStates: {
          ...inMemory.appStates,
          chatDisconnectEventReceived: action.payload
        }
      };
      return {
        ...state,
        appStates: {
          ...state.appStates,
          chatDisconnectEventReceived: action.payload
        }
      };
    case LiveChatWidgetActionType.SET_SURVEY_MODE:
      inMemory = {
        ...inMemory,
        appStates: {
          ...inMemory.appStates,
          selectedSurveyMode: action.payload
        }
      };
      return {
        ...state,
        appStates: {
          ...state.appStates,
          selectedSurveyMode: action.payload
        }
      };
    case LiveChatWidgetActionType.SET_CONFIRMATION_STATE:
      inMemory = {
        ...inMemory,
        domainStates: {
          ...inMemory.domainStates,
          confirmationState: action.payload
        }
      };
      return {
        ...state,
        domainStates: {
          ...state.domainStates,
          confirmationState: action.payload
        }
      };
    case LiveChatWidgetActionType.SET_POST_CHAT_PARTICIPANT_TYPE:
      inMemory = {
        ...inMemory,
        appStates: {
          ...inMemory.appStates,
          postChatParticipantType: action.payload
        }
      };
      return {
        ...state,
        appStates: {
          ...state.appStates,
          postChatParticipantType: action.payload
        }
      };
    case LiveChatWidgetActionType.GET_IN_MEMORY_STATE:
      return inMemory;
    default:
      return state;
  }
};