import { useContext } from "react";
import { ChatContextStore } from "../contexts/ChatContextStore";
const useChatContextStore = () => {
  const context = useContext(ChatContextStore);
  if (!context) {
    throw new Error("This hook can only be used on component that is descendants of <ChatContextStore.Provider>");
  }
  return context;
};
export default useChatContextStore;