import { TelemetryData } from "./definitions/Payload";
export declare enum ScenarioType {
    CONFIG_VALIDATION = "LCW_ConfigValidationEvents",
    LOAD = "LCW_LoadEvents",
    ACTIONS = "LCW_ActionEvents",
    SDK = "LCW_SDKEvents",
    IC3_CLIENT = "LCW_IC3ClientEvents",
    OCCHATSDK = "LCW_OCCHATSDKEvents",
    WEBCHAT = "LCW_WebChatEvents",
    CALLING = "LCW_Calling",
    UNDEFINED = "LCW_Undefined",
    ACS_ADAPTER = "LCW_ACSAdapterEvents"
}
export declare enum LogLevel {
    INFO = "INFO",
    DEBUG = "DEBUG",
    WARN = "WARN",
    ERROR = "ERROR"
}
export declare enum BroadcastEvent {
    LoadPostChatSurvey = "LoadPostChatSurvey",
    ChatEnded = "ChatEnded",// used for multitab notification when chat ended 
    NewMessageNotification = "NewMessageNotification",
    UnreadMessageCount = "UnreadMessageCount",
    StartProactiveChat = "StartProactiveChat",
    ProactiveChatStartChat = "ProactiveChatStartChat",
    ProactiveChatStartPopoutChat = "ProactiveChatStartPopoutChat",
    ResetProactiveChatParams = "ResetProactiveChatParams",
    InvalidAdaptiveCardFormat = "InvalidAdaptiveCardFormat",
    NewMessageSent = "NewMessageSent",
    NewMessageReceived = "NewMessageReceived",
    HistoryMessageReceived = "HistoryMessageReceived",
    RedirectPageRequest = "RedirectPageRequest",
    StartChat = "StartChat",
    StartUnauthenticatedReconnectChat = "StartUnauthenticatedReconnectChat",
    InitiateEndChat = "InitiateEndChat",
    SetCustomContext = "SetCustomContext",
    ChatRetrievedFromCache = "ChatRetrievedFromCache",
    MaximizeChat = "MaximizeChat",
    ChatInitiated = "ChatInitiated",
    CloseChat = "CloseChat",
    InitiateEndChatOnBrowserUnload = "InitiateEndChatOnBrowserUnload",
    ClosePopoutWindow = "ClosePopoutWindow",
    RaiseErrorEvent = "RaiseErrorEvent",
    NetworkDisconnected = "NetworkDisconnected",
    NetworkReconnected = "NetworkReconnected",
    SigninCardReceived = "SignInCardReceived",
    BotAuthConfigRequest = "BotAuthConfigRequest",
    BotAuthConfigResponse = "BotAuthConfigResponse",
    RemoveWidgetDataFromCache = "RemoveWidgetDataFromCache",
    InitiateStartChatInPopoutMode = "InitiateStartChatInPopoutMode",
    HideChatVisibilityChangeEvent = "hideChatVisibilityChangeEvent",
    UpdateSessionDataForTelemetry = "UpdateSessionDataForTelemetry",
    UpdateConversationDataForTelemetry = "UpdateConversationDataForTelemetry",
    ContactIdNotFound = "ContactIdNotFound",
    SyncMinimize = "SyncMinimize",
    OnWidgetError = "OnWidgetError",
    FMLTrackingCompletedAck = "FMLTrackingCompletedAck",
    FMLTrackingCompleted = "FMLTrackingCompleted"
}
export declare enum TelemetryEvent {
    CallAdded = "CallAdded",
    LocalVideoStreamAdded = "LocalVideoStreamAdded",
    LocalVideoStreamRemoved = "LocalVideoStreamRemoved",
    RemoteVideoStreamAdded = "RemoteVideoStreamAdded",
    RemoteVideoStreamRemoved = "RemoteVideoStreamRemoved",
    CallDisconnected = "CallDisconnected",
    CallDisconnectedException = "CallDisconnectedException",
    IncomingCallEnded = "incomingCallEnded",//case sensitive
    VoiceVideoSdkInitialize = "VoiceVideoSdkInitialize",
    VoiceVideoSdkInitializeException = "VoiceVideoSdkInitializeException",
    VoiceVideoLoading = "VoiceVideoLoading",
    VoiceVideoNotLoaded = "VoiceVideoNotLoaded",
    VoiceVideoLoadingException = "VoiceVideoLoadingException",
    VoiceVideoAcceptCallException = "VoiceVideoAcceptCallException",
    VoiceVideoAcceptCallWithVideoException = "VoiceVideoAcceptCallWithVideoException",
    VideoCallAcceptButtonClick = "VideoCallAcceptButtonClick",
    VoiceCallAcceptButtonClick = "VoiceCallAcceptButtonClick",
    CallRejectClick = "CallRejectClick",
    CallRejectClickException = "CallRejectClickException",
    ToggleMuteButtonClick = "ToggleMuteButtonClick",
    ToggleMuteButtonClickException = "ToggleMuteButtonClickException",
    ToggleCameraButtonClick = "ToggleCameraButtonClick",
    ToggleCameraButtonClickException = "ToggleCameraButtonClickException",
    EndCallButtonClick = "EndCallButtonClick",
    EndCallButtonClickException = "EndCallButtonClickException",
    CallingSDKInitSuccess = "CallingSDKInitSuccess",
    CallingSDKInitFailed = "CallingSDKInitFailed",
    CallingSDKLoadSuccess = "CallingSDKLoadSuccess",
    CallingSDKLoadFailed = "CallingSDKLoadFailed",
    GetConversationDetailsCallStarted = "GetConversationDetailsCallStarted",
    GetConversationDetailsCallFailed = "GetConversationDetailsCallFailed",
    EndChatSDKCallFailed = "EndChatSDKCallFailed",
    DisconnectEndChatSDKCallFailed = "DisconnectEndChatSDKCallFailed",
    GetChatReconnectContextSDKCallStarted = "GetChatReconnectContextSDKCallStarted",
    GetChatReconnectContextSDKCallFailed = "GetChatReconnectContextSDKCallFailed",
    CheckContactIdError = "checkContactIdError",
    GetChatReconnectContextSDKCallSucceeded = "GetChatReconnectContextSDKCallSucceeded",
    ParseAdaptiveCardFailed = "ParseAdaptiveCardFailed",
    ClientDataStoreProviderFailed = "ClientDataStoreProviderFailed",
    InMemoryDataStoreFailed = "InMemoryDataStoreFailed",
    ChatVisibilityChanged = "ChatVisibilityChanged",
    EndChatSucceeded = "EndChatSucceeded",
    EndChatFailed = "EndChatFailed",
    SettingCustomContext = "SettingCustomContext",
    WebChatLoaded = "WebChatLoaded",
    LCWChatButtonActionCompleted = "LCWChatButtonActionCompleted",
    LCWChatButtonClicked = "LCWChatButtonClicked",
    LCWChatButtonShow = "LCWChatButtonShow",
    WidgetLoadStarted = "WidgetLoadStarted",
    WidgetLoadComplete = "WidgetLoadComplete",
    WidgetLoadFailed = "WidgetLoadFailed",
    StartChatMethodException = "StartChatMethodException",
    CloseChatCall = "CloseChatCall",
    CloseChatMethodException = "CloseChatMethodException",
    PrechatSurveyLoaded = "PrechatSurveyLoaded",
    PrechatSurveyExpected = "PrechatSurveyExpected",
    PrechatSubmitted = "PrechatSubmitted",
    StartChatSDKCall = "StartChatCall",
    StartChatEventReceived = "StartChatEventReceived",
    EndChatSDKCall = "EndChatSDKCall",
    PrepareEndChat = "PrepareEndChat",
    EndChatEventReceived = "EndChatEventReceived",
    WindowClosed = "WindowClosed",
    OnNewMessageFailed = "OnNewMessageFailed",
    OnNewMessageAudioNotificationFailed = "OnNewMessageAudioNotificationFailed",
    DownloadTranscriptResponseNullOrUndefined = "DownloadTranscriptResponseNullOrUndefined",
    ErrorUIPaneLoaded = "ErrorUIPaneLoaded",
    DownloadTranscriptFailed = "DownloadTranscriptFailed",
    StartChatFailed = "StartChatFailed",
    ConfirmationCancelButtonClicked = "ConfirmationCancelButtonClicked",
    ConfirmationConfirmButtonClicked = "ConfirmationConfirmButtonClicked",
    LoadingPaneLoaded = "LoadingPaneLoaded",
    LoadingPaneUnloaded = "LoadingPaneUnloaded",
    StartChatErrorPaneLoaded = "StartChatErrorPaneLoaded",
    EmailTranscriptLoaded = "EmailTranscriptLoaded",
    OutOfOfficePaneLoaded = "OutOfOfficePaneLoaded",
    ConfirmationPaneLoaded = "ConfirmationPaneLoaded",
    ProactiveChatPaneLoaded = "ProactiveChatPaneLoaded",
    ReconnectChatPaneLoaded = "ReconnectChatPaneLoaded",
    HeaderCloseButtonClicked = "HeaderCloseButtonClicked",
    CloseChatActionCompleted = "CloseChatActionCompleted",
    HeaderMinimizeButtonClicked = "HeaderMinimizeButtonClicked",
    MinimizeChatActionCompleted = "MinimizeChatActionCompleted",
    NotificationCloseChatButtonClicked = "NotificationCloseChatButtonClicked",
    NotificationDismissButtonClicked = "NotificationDismissButtonClicked",
    DownloadTranscriptButtonClicked = "DownloadTranscriptButtonClicked",
    DownloadTranscriptActionCompleted = "DownloadTranscriptActionCompleted",
    DownloadTranscriptActionFailed = "DownloadTranscriptActionFailed",
    EmailTranscriptButtonClicked = "EmailTranscriptButtonClicked",
    EmailTranscriptSent = "EmailTranscriptSent",
    EmailTranscriptFailed = "EmailTranscriptFailed",
    EmailTranscriptCancelButtonClicked = "EmailTranscriptCancelButtonClicked",
    AudioToggleButtonClicked = "AudioToggleButtonClicked",
    SuppressBotMagicCodeSucceeded = "SuppressBotMagicCodeSucceeded",
    SuppressBotMagicCodeFailed = "SuppressBotMagicCodeFailed",
    GetConversationDetailsException = "GetConversationDetailsException",
    AppStatesException = "AppStatesException",
    BrowserUnloadEventStarted = "BrowserUnloadEventStarted",
    GetAuthTokenCalled = "GetAuthTokenCalled",
    GetAuthTokenFailed = "GetAuthTokenFailed",
    ReceivedNullOrEmptyToken = "ReceivedNullOrEmptyToken",
    CustomerVoiceResponsePageLoaded = "CustomerVoiceResponsePageLoaded",
    CustomerVoiceFormResponseSubmitted = "CustomerVoiceFormResponseSubmitted",
    CustomerVoiceFormResponseError = "CustomerVoiceFormResponseError",
    CustomerVoiceFormsError = "CustomerVoiceFormsError",
    BotAuthActivityEmptySasUrl = "BotAuthActivityEmptySasUrl",
    SetBotAuthProviderFetchConfig = "SetBotAuthProviderFetchConfig",
    SetBotAuthProviderHideCard = "SetBotAuthProviderHideCard",
    SetBotAuthProviderDisplayCard = "SetBotAuthProviderDisplayCard",
    SetBotAuthProviderNotFound = "SetBotAuthProviderNotFound",
    BotAuthActivityUndefinedSignInId = "BotAuthActivityUndefinedSignInId",
    ThirdPartyCookiesBlocked = "ThirdPartyCookiesBlocked",
    ParticipantsRemovedEvent = "ParticipantsRemovedEvent",
    ProcessingHTMLTextMiddlewareFailed = "ProcessingHTMLTextMiddlewareFailed",
    ProcessingSanitizationMiddlewareFailed = "ProcessingSanitizationMiddlewareFailed",
    FormatTagsMiddlewareJSONStringifyFailed = "FormatTagsMiddlewareJSONStringifyFailed",
    AttachmentUploadValidatorMiddlewareFailed = "AttachmentUploadValidatorMiddlewareFailed",
    QueuePositionMessageRecieved = "QueuePositionMessageRecieved",
    AverageWaitTimeMessageRecieved = "AverageWaitTimeMessageRecieved",
    DataMaskingRuleApplied = "DataMaskingRuleApplied",
    DataMaskingRuleApplyFailed = "DataMaskingRuleApplyFailed",
    IC3ClientEvent = "IC3ClientEvent",
    ConversationEndedThreadEventReceived = "ConversationEndedThreadEventReceived",
    ConversationEndedByCustomer = "ConversationEndedByCustomer",
    ConversationEndedByAgent = "ConversationEndedByAgent",
    InvalidConfiguration = "InvalidConfiguration",
    SendTypingIndicatorSucceeded = "SendTypingIndicatorSucceeded",
    SendTypingIndicatorFailed = "SendTypingIndicatorFailed",
    WebChatEvent = "WebChatEvent",
    FacadeChatSDKEvent = "FacadeChatSDKEvent",
    PreChatSurveyStartChatMethodFailed = "PreChatSurveyStartChatMethodFailed",
    ChatAlreadyTriggered = "ChatAlreadyTriggered",
    StartProactiveChatEventReceived = "StartProactiveChatEventReceived",
    StartProactiveChatMethodFailed = "StartProactiveChatMethodFailed",
    ProactiveChatAccepted = "ProactiveChatAccepted",
    ProactiveChatRejected = "ProactiveChatRejected",
    IncomingProactiveChatScreenLoaded = "IncomingProactiveChatScreenLoaded",
    ProactiveChatClosed = "ProactiveChatClosed",
    ReconnectChatContinueConversation = "ReconnectChatContinueConversation",
    ReconnectChatStartNewConversation = "ReconnectChatStartNewConversation",
    ReconnectChatMinimize = "ReconnectChatMinimize",
    MessageSent = "MessageSent",
    MessageReceived = "MessageReceived",
    MessageLapTrack = "MessageLapTrack",
    BotFirstMessageLapTrack = "BotFirstMessageLapTrack",
    BotFirstMessageLapTrackError = "BotFirstMessageLapTrackError",
    MessageStartLapTrackError = "MessageStartLapTrackError",
    MessageStopLapTrackError = "MessageStopLapTrackError",
    SystemMessageReceived = "SystemMessageReceived",
    RehydrateMessageReceived = "RehydrateMessageReceived",
    CustomContextReceived = "CustomContextReceived",
    NetworkDisconnected = "NetworkDisconnected",
    NetworkReconnected = "NetworkReconnected",
    LinkModePostChatWorkflowStarted = "LinkModePostChatWorkflowStarted",
    EmbedModePostChatWorkflowStarted = "EmbedModePostChatWorkflowStarted",
    PostChatWorkflowFromCustomer = "PostChatWorkflowFromCustomer",
    PostChatWorkflowFromAgent = "PostChatWorkflowFromAgent",
    PostChatWorkflowFromBot = "PostChatWorkflowFromBot",
    PostChatContextCallStarted = "PostChatContextCallStarted",
    PostChatContextCallSucceed = "PostChatContextCallSucceed",
    PostChatContextCallFailed = "PostChatContextCallFailed",
    PostChatSurveyLoadingPaneLoaded = "PostChatSurveyLoadingPaneLoaded",
    PostChatSurveyLoaded = "PostChatSurveyLoaded",
    PostChatSurveyUrlValidationCompleted = "PostChatSurveyUrlValidationCompleted",
    PostChatSurveyUrlValidationFailed = "PostChatSurveyUrlValidationFailed",
    ChatDisconnectThreadEventReceived = "ChatDisconnectThreadEventReceived",
    HiddenAdaptiveCardMessageReceived = "HiddenAdaptiveCardMessageReceived",
    EndingAdapterAfterDisconnectionError = "EndingAdapterAfterDisconnectionError",
    NewTokenValidationStarted = "NewTokenValidationStarted",
    NewTokenValidationCompleted = "NewTokenValidationCompleted",
    NewTokenValidationFailed = "NewTokenValidationFailed",
    TokenEmptyOrSame = "TokenEmptyOrSame",
    UXFooterStart = "UXFooterStart",
    UXFooterCompleted = "UXFooterCompleted",
    UXHeaderStart = "UXHeaderStart",
    UXHeaderCompleted = "UXHeaderCompleted",
    UXLoadingPaneStart = "UXLoadingPaneStart",
    UXLoadingPaneCompleted = "UXLoadingPaneCompleted",
    UXNotificationPaneStart = "UXNotificationPaneStart",
    UXNotificationPaneCompleted = "UXNotificationPaneCompleted",
    UXOutOfOfficeHoursPaneStart = "UXOutOfOfficeHoursPaneStart",
    UXOutOfOfficeHoursPaneCompleted = "UXOutOfOfficeHoursPaneCompleted",
    XSSTextDetected = "XSSTextDetected",
    UXPostChatLoadingPaneStart = "UXPostChatLoadingPaneStart",
    UXPostChatLoadingPaneCompleted = "UXPostChatLoadingPaneCompleted",
    UXPrechatPaneStart = "UXPrechatPaneStart",
    UXPrechatPaneCompleted = "UXPrechatPaneCompleted",
    UXProactiveChatPaneStart = "UXProactiveChatPaneStart",
    UXProactiveChatPaneCompleted = "UXProactiveChatPaneCompleted",
    UXReconnectChatPaneStart = "UXReconnectChatPaneStart",
    UXReconnectChatCompleted = "UXReconnectChatCompleted",
    UXStartChatErrorPaneStart = "UXStartChatErrorPaneStart",
    UXStartChatErrorCompleted = "UXStartChatErrorCompleted",
    UXEmailTranscriptPaneStart = "UXEmailTranscriptPaneStart",
    UXEmailTranscriptPaneCompleted = "UXEmailTranscriptPaneCompleted",
    UXWebchatContainerStart = "UXWebchatContainerStart",
    UXWebchatContainerCompleted = "UXWebchatContainerCompleted",
    UXLCWChatButtonLoadingStart = "UXLCWChatButtonLoadingStart",
    UXLCWChatButtonLoadingCompleted = "UXLCWChatButtonLoadingCompleted",
    UXConfirmationPaneStart = "UXConfirmationPaneStart",
    UXConfirmationPaneCompleted = "UXConfirmationPaneCompleted",
    UXLiveChatWidgetStart = "UXLiveChatWidgetStart",
    UXLiveChatWidgetCompleted = "UXLiveChatWidgetCompleted",
    AppInsightsInitialized = "AppInsightsInitialized",
    AppInsightsInitFailed = "AppInsightsInitFailed"
}
export interface TelemetryInput {
    scenarioType: ScenarioType;
    payload: TelemetryData;
    telemetryInfo?: any;
}
export declare class TelemetryConstants {
    private static map;
    static mapEventToScenario(eventTypeOrScenarioType: TelemetryEvent): ScenarioType;
}
