import React, { ReactNode } from "react";
interface IDraggableEventEmitterProps {
    /**
     * Unique channel name to send/receive draggable events to prevent event collisions
     */
    channel: string;
    /**
     * React nodes children
     */
    children: ReactNode;
    /**
     * HTML element ID of the trigger element to send IDraggableEvent to update the draggable element position
     */
    elementId: string;
    /**
     * Target window to post IDraggableEvent messages
     */
    targetWindow?: Window;
}
/**
 * Trigger component which would send IDraggableEvent to the receiver to update the draggable component position
 *
 * @param props IDraggableEventEmitterProps
 * @returns
 */
declare const DraggableEventEmitter: (props: IDraggableEventEmitterProps) => React.JSX.Element;
export default DraggableEventEmitter;
