import React, { ReactNode } from "react";
import IDraggableEvent from "./IDraggableEvent";
interface IDraggableEventReceiverProps {
    /**
     * Unique channel name to send/receive draggable events to prevent event collisions
     */
    channel: string;
    /**
     * React nodes children
     */
    children: ReactNode;
    /**
     * Event handler on receiving draggable events
     *
     * @param event Draggable events
     * @returns
     */
    onEvent: (event: IDraggableEvent) => void;
}
/**
 * Component which would listen to DraggableEvent, update the component position or react accordingly.
 *
 * @param props IDraggableEventReceiverProps
 * @returns
 */
declare const DraggableEventReceiver: (props: IDraggableEventReceiverProps) => React.JSX.Element;
export default DraggableEventReceiver;
