import ChatConfig from "@microsoft/omnichannel-chat-sdk/lib/core/ChatConfig";
import { IAudioNotificationProps } from "../../footerstateful/audionotificationstateful/interfaces/IAudioNotificationProps";
import { ICallingContainerProps } from "@microsoft/omnichannel-chat-components/lib/types/components/callingcontainer/interfaces/ICallingContainerProps";
import { IChatButtonProps } from "@microsoft/omnichannel-chat-components/lib/types/components/chatbutton/interfaces/IChatButtonProps";
import { IConfirmationPaneStatefulProps } from "../../confirmationpanestateful/interfaces/IConfirmationPaneStatefulProps";
import { IContextDataStore } from "../../../common/interfaces/IContextDataStore";
import { IDownloadTranscriptProps } from "../../footerstateful/downloadtranscriptstateful/interfaces/IDownloadTranscriptProps";
import { IDraggableChatWidgetProps } from "./IDraggableChatWidgetProps";
import { IEmailTranscriptPaneProps } from "../../emailtranscriptpanestateful/interfaces/IEmailTranscriptPaneProps";
import { IFeatureConfigProps } from "./IFeatureConfigProps";
import { IFooterProps } from "@microsoft/omnichannel-chat-components/lib/types/components/footer/interfaces/IFooterProps";
import { IHeaderProps } from "@microsoft/omnichannel-chat-components/lib/types/components/header/interfaces/IHeaderProps";
import { ILiveChatWidgetComponentOverrides } from "./ILiveChatWidgetComponentOverrides";
import { ILiveChatWidgetContext } from "../../../contexts/common/ILiveChatWidgetContext";
import { ILiveChatWidgetControlProps } from "./ILiveChatWidgetControlProps";
import { ILiveChatWidgetStyleProps } from "./ILiveChatWidgetStyleProps";
import { ILoadingPaneProps } from "@microsoft/omnichannel-chat-components/lib/types/components/loadingpane/interfaces/ILoadingPaneProps";
import { IMockProps } from "./IMockProps";
import { INotificationPaneProps } from "@microsoft/omnichannel-chat-components/lib/types/components/notificationpane/interfaces/INotificationPaneProps";
import { IOOOHPaneProps } from "@microsoft/omnichannel-chat-components/lib/types/components/outofofficehourspane/interfaces/IOOOHPaneProps";
import { IPostChatSurveyPaneStatefulProps } from "../../postchatsurveypanestateful/interfaces/IPostChatSurveyPaneStatefulProps";
import { IPreChatSurveyPaneProps } from "@microsoft/omnichannel-chat-components/lib/types/components/prechatsurveypane/interfaces/IPreChatSurveyPaneProps";
import { IProactiveChatPaneStatefulProps } from "../../proactivechatpanestateful/interfaces/IProactiveChatPaneStatefulProps";
import { IReconnectChatPaneStatefulProps } from "../../reconnectchatpanestateful/interfaces/IReconnectChatPaneStatefulProps";
import { IScrollBarProps } from "./IScrollBarProps";
import { IStartChatErrorPaneProps } from "../../startchaterrorpanestateful/interfaces/IStartChatErrorPaneProps";
import { ITelemetryConfig } from "../../../common/telemetry/interfaces/ITelemetryConfig";
import { IWebChatContainerStatefulProps } from "../../webchatcontainerstateful/interfaces/IWebChatContainerStatefulProps";
import { OmnichannelChatSDK } from "@microsoft/omnichannel-chat-sdk";
import { IAppInsightsConfig } from "../../../common/telemetry/interfaces/IAppInsightsConfig";
export interface ILiveChatWidgetProps {
    audioNotificationProps?: IAudioNotificationProps;
    callingContainerProps?: ICallingContainerProps;
    chatButtonProps?: IChatButtonProps;
    chatConfig?: ChatConfig;
    chatSDK: OmnichannelChatSDK;
    componentOverrides?: ILiveChatWidgetComponentOverrides;
    confirmationPaneProps?: IConfirmationPaneStatefulProps;
    controlProps?: ILiveChatWidgetControlProps;
    directLine?: any;
    downloadTranscriptProps?: IDownloadTranscriptProps;
    emailTranscriptPane?: IEmailTranscriptPaneProps;
    footerProps?: IFooterProps;
    headerProps?: IHeaderProps;
    loadingPaneProps?: ILoadingPaneProps;
    outOfOfficeChatButtonProps?: IChatButtonProps;
    outOfOfficeHeaderProps?: IHeaderProps;
    outOfOfficeHoursPaneProps?: IOOOHPaneProps;
    postChatLoadingPaneProps?: ILoadingPaneProps;
    postChatSurveyPaneProps?: IPostChatSurveyPaneStatefulProps;
    preChatSurveyPaneProps?: IPreChatSurveyPaneProps;
    proactiveChatPaneProps?: IProactiveChatPaneStatefulProps;
    reconnectChatPaneProps?: IReconnectChatPaneStatefulProps;
    startChatErrorPaneProps?: IStartChatErrorPaneProps;
    styleProps?: ILiveChatWidgetStyleProps;
    telemetryConfig: ITelemetryConfig;
    notificationPaneProps?: INotificationPaneProps;
    webChatContainerProps?: IWebChatContainerStatefulProps;
    liveChatContextFromCache?: ILiveChatWidgetContext;
    contextDataStore?: IContextDataStore;
    getAuthToken?: (authClientFunction?: string) => Promise<string | null>;
    scrollBarProps?: IScrollBarProps;
    useSessionStorage?: boolean;
    allowSdkChatSupport?: boolean;
    initialCustomContext?: any;
    draggableChatWidgetProps?: IDraggableChatWidgetProps;
    mock?: IMockProps;
    featureConfigProps?: IFeatureConfigProps;
    appInsightsConfig?: IAppInsightsConfig;
}
