import { DesignerChatAdapter } from "./DesignerChatAdapter";
import { MockChatSDK } from "./mockchatsdk";
export declare class DesignerChatSDK extends MockChatSDK {
    constructor();
    createChatAdapter(): DesignerChatAdapter;
    localeId: string;
    /**
    * If the widget is running in designer mode, we mock the initialize response. We don't want
    * any interactions with a real server in when designing LCW widget visually in Modern Admin.
    *
    * - All GUIDs were changed to 00000000-0000-0000-0000-000000000000.
    * - msdyn_callingoptions was changed to disable calling functionality
    */
    getLiveChatConfig(): {
        LiveWSAndLiveChatEngJoin: {
            msdyn_widgetthemecolor: string;
            msdyn_callingoptions: string;
            msdyn_widgettitle: string;
            msdyn_conversationmode: string;
            msdyn_avatarurl: string;
            msdyn_name: string;
            msdyn_postconversationsurveyenable: string;
            OutOfOperatingHours: string;
            ShowWidget: string;
        };
        ChatWidgetLanguage: {
            msdyn_localeid: string;
            msdyn_languagename: string;
        };
    };
}
