import { ActivityMiddleware, ActivityStatusMiddleware, AttachmentForScreenReaderMiddleware, AttachmentMiddleware, AvatarMiddleware, CardActionMiddleware, GroupActivitiesMiddleware, ScrollToEndButtonMiddleware, ToastMiddleware, TypingIndicatorMiddleware, WebSpeechPonyfillFactory } from "botframework-webchat-api";
import { ComponentType, ReactNode } from "react";
import { DirectLineActivity, OneOrMany } from "botframework-webchat-core";
export interface IWebChatProps {
    activityMiddleware?: OneOrMany<ActivityMiddleware>;
    activityStatusMiddleware?: OneOrMany<ActivityStatusMiddleware>;
    adaptiveCardsHostConfig?: any;
    attachmentForScreenReaderMiddleware?: OneOrMany<AttachmentForScreenReaderMiddleware>;
    attachmentMiddleware?: OneOrMany<AttachmentMiddleware>;
    avatarMiddleware?: OneOrMany<AvatarMiddleware>;
    cardActionMiddleware?: OneOrMany<CardActionMiddleware>;
    children?: ReactNode;
    dir?: string;
    disabled?: boolean;
    downscaleImageToDataURL?: (blob: Blob, maxWidth: number, maxHeight: number, type: string, quality: number) => Promise<URL>;
    grammars?: any;
    groupActivitiesMiddleware?: OneOrMany<GroupActivitiesMiddleware>;
    internalErrorBoxClass?: ComponentType<any>;
    internalRenderErrorBox?: any;
    locale?: string;
    onTelemetry?: any;
    overrideLocalizedStrings?: any;
    renderMarkdown?: any;
    scrollToEndButtonMiddleware?: OneOrMany<ScrollToEndButtonMiddleware>;
    selectVoice?: (voices: typeof window.SpeechSynthesisVoice[], activity: DirectLineActivity) => void;
    sendTypingIndicator?: boolean;
    store?: any;
    toastMiddleware?: OneOrMany<ToastMiddleware>;
    typingIndicatorMiddleware?: OneOrMany<TypingIndicatorMiddleware>;
    userID?: string;
    username?: string;
    extraStyleSet?: any;
    nonce?: string;
    styleSet?: any;
    suggestedActionsAccessKey?: boolean | string;
    webSpeechPonyfillFactory?: WebSpeechPonyfillFactory;
    className?: string;
    role?: "complementary" | "contentinfo" | "form" | "main" | "region";
}
